#ifdef ice_model

      SUBROUTINE ADVECT(UICE1,VICE1,HEFF,DIFF1,LAD)
#include "size.h"
#include "size_ice.h"
      DIMENSION HEFF(NX1,NY1,3),UICE1(NX1,NY1,3),VICE1(NX1,NY1,3)
c     1,UICE(NX1,NY1),VICE(NX1,NY1),DIFFA(NX1,NY1)
     1,UICE(NX1,NY1),VICE(NX1,NY1),DIFFX(NX1,NY1),DIFFY(NX1,NY1)
      COMMON/STEP1/DELTAT,DELTAX,DELTAY
      COMMON/ARRAY/HEFFM(NX1,NY1),UVM(NX1,NY1)
      COMMON/NORTHPOLE/SCALENP
      COMMON /ICEGRID/DXT(NX1),DYT(NY1),DXU(NX1),DYU(NY1)
     1       ,CST(NY1),CSU(NY1),TNGT(NY1),TNG(NY1),SINE(NY1)
C NOW DECIDE IF BACKWARD EULER OR LEAPFROG
      LL=LAD
      IF(LL.EQ.1) GO TO 100
C BACKWARD EULER
      DELTT=DELTAT
      K3=2
      K2=2
      GO TO 101
C LEAPFROG
 100  DELTT=DELTAT*2.0
      K3=3
      K2=2
 101  CONTINUE
C NOW REARRANGE H'S
      DO 401 J=1,NY1
      DO 401 I=1,NX1
      UICE(I,J)=UICE1(I,J,1)
      VICE(I,J)=VICE1(I,J,1)
 401  CONTINUE
      DO 200 J=1,NY1
      DO 200 I=1,NX1
      HEFF(I,J,3)=HEFF(I,J,2)
      HEFF(I,J,2)=HEFF(I,J,1)
 200  CONTINUE
 202  CONTINUE
C NOW GO THROUGH STANDARD CONSERVATIVE ADVECTION
      DO 210 J=1,NYM1
      DO 210 I=1,NXM1
      HEFF(I+1,J+1,1)=HEFF(I+1,J+1,K3)-DELTT*((HEFF(I+1,J+1,2)+HEFF
     1(I+2,J+1,2))*(UICE(I+1,J+1)+UICE(I+1,J))-(HEFF(I+1,J+1,2)+HEFF
     2(I,J+1,2))*(UICE(I,J+1)+UICE(I,J)))*(0.25/(DXT(I+1)*CST(J+1)))
     3-DELTT*((HEFF(I+1,J+1,2)+HEFF(I+1,J+2,2))*(VICE(I,J+1)
     3+VICE(I+1,J+1))*CSU(J+1)-(HEFF(I+1,J+1,2)+HEFF(I+1,J,2))
     4*(VICE(I,J)+VICE(I+1,J))*CSU(J))*(0.25/(DYT(J+1)*CST(J+1))) 
 210  CONTINUE
#ifdef northpole
      AAA=0.0
      DO J=NYM1,NYM1
      DO I=1,NXM1
      AAA=AAA+(HEFF(I+1,J+1,2)+HEFF(I+1,J+2,2))
     1*(VICE(I,J+1)+VICE(I+1,J+1))*CSU(J+1)*(0.25/(DYT(J+1)*CST(J+1)))
      END DO
      END DO
      SCALENP=HEFF(3,NY1,K3)+DELTT*AAA
      DO I=1,NXM1
      HEFF(I+1,NY1,1)=HEFF(I+1,NY1,K3)+DELTT*AAA
      END DO
#endif
#ifdef cyclic
      DO J=2,NY1
      HEFF(1,J,1)=HEFF(NX,J,1)
      HEFF(NX1,J,1)=HEFF(2,J,1)
      END DO
#endif

C NOW DECIDE IF DONE
      IF(LL.EQ.2) GO TO 99
      IF (LL.EQ.3) GO TO 89
      GO TO 102
 89   CONTINUE
C  NOW FIX UP H(I,J,2)
      DO 88 J=1,NY1
      DO 88 I=1,NX1
      HEFF(I,J,2)=HEFF(I,J,3)
 88   CONTINUE
      GO TO 102
 99   CONTINUE
C NOW DO BACKWARD EULER CORRECTION
      DO 220 J=1,NY1
      DO 220 I=1,NX1
      HEFF(I,J,3)=HEFF(I,J,2)
      HEFF(I,J,2)=0.5*(HEFF(I,J,1)+HEFF(I,J,2))
 220  CONTINUE
      LL=3
      K3=3
      GO TO 202
 102  CONTINUE
C NOW DO DIFFUSION ON H(I,J,K3)
      DO 240 KD=1,2
      GO TO (241,242),KD
 241  CONTINUE
C NOW CALCULATE DIFFUSION COEF ROUGHLY
      DO I=1,NX1
      DO J=1,NY1
      DIFFX(I,J)=DIFF1*MIN(DXT(I)*CST(J),DYT(J))
      DIFFY(I,J)=DIFF1*MIN(DXT(I)*CST(J),DYT(J))
      END DO
      END DO
c      CALL DIFFUS(UICE,VICE,HEFF,DIFFA,DELTT)
      CALL DIFFUS(UICE,VICE,HEFF,DIFFX,DIFFY,DELTT)
      DO J=1,NY1
      DO I=1,NX1
      HEFF(I,J,3)=HEFF(I,J,3)*HEFFM(I,J)
      END DO
      END DO
      GO TO 243
 242  CONTINUE
C NOW CALCULATE DIFFUSION COEF ROUGHLY
      DO I=1,NX1
      DO J=1,NY1
      DIFFX(I,J)=-1.2*(MIN(DXT(I)*CST(J),DYT(J)))**2/DELTT
      DIFFY(I,J)=-1.2*(MIN(DXT(I)*CST(J),DYT(J)))**2/DELTT
      END DO
      END DO
c      CALL DIFFUS(UICE,VICE,HEFF,DIFFA,DELTT)
      CALL DIFFUS(UICE,VICE,HEFF,DIFFX,DIFFY,DELTT)
 243  CONTINUE
      DO 330 J=1,NY1
      DO 330 I=1,NX1
      HEFF(I,J,1)=(HEFF(I,J,1)+HEFF(I,J,3))*HEFFM(I,J)
 330  CONTINUE
 240  CONTINUE
      RETURN
      END
c

#else
      subroutine advect
      return
      end
c
#endif
