#ifdef ice_model

      SUBROUTINE BUDGET(TICE,HICE1,FICE,HSENS,HLATE
     &,KOPEN)
#include "size.h"
#include "size_ice.h"
      DIMENSION TICE(NX1,NY1),HICE(NX1,NY1),FICE(NX1,NY1)
     ?,A1(NX1,NY1),A2(NX1,NY1),A3(NX1,NY1),B(NX1,NY1),ALB(NX1,NY1)
     ?,HICE1(NX1,NY1)
      COMMON/COUNT/ICOUNT
      COMMON/BUD/TAIR(NX1,NY1),QA(NX1,NY1),FLO(NX1,NY1)
     ?,FSH(NX1,NY1),UG(NX1,NY1)
      COMMON/SNOW/HSNO(NX1,NY1)
      DIMENSION HSENS(NX1,NY1),HLATE(NX1,NY1)
      COMMON/FW1/FW(NX1,NY1)
C IF KOPEN LT 0 THAN DO OPEN WATER BUDGET
C NOW DEFINE ASSORTED CONSTANTS
C SATURATION VAPOR PRESSURE CONSTANT
      QS1=0.622E+00/1013.0E+00
C MAYKUTS CONSTANTS FOR SAT. VAP. PRESSURE TEMP. POLYNOMIAL
      C1=2.7798202D-06
      C2=-2.6913393D-03
      C3=0.97920849E+00
      C4=-158.63779E+00
      C5=9653.1925E+00
C INVERSE HEAT OF FUSION OF ICE
      Q0=1.0D-06/302.0E+00
C OCEANIC HEAT FLUX (DOWNWARD POSITIVE)
C      FW=0.0
C FREEZING TEMPERATURE OF SEAWATER
      TB=271.2E+00
c modify TB to be consistent with ocean model
c      TB=271.04E+00
C NO. OF ITERATIONS FOR ICE HEAT BUDGET
      IMAX=3
C SENSIBLE HEAT CONSTANT
      D1=2.284E+00
C WATER LATENT HEAT CONSTANT
      D1W=5.6875D+03
C ICE LATENT HEAT CONSTANT
      D1I=6.4474D+03
C STEFAN BOLTZMAN CONSTANT TIMES 0.97 EMISSIVITY
      D3=5.5D-08
C MELTING TEMPERATURE OF ICE
      TMELT=273.16E+00
      TMELTP=273.159E+00
C ICE CONDUCTIVITY 
      XKI=2.1656E+00
C SNOW CONDUCTIVITY 
      XKS=3.1D-01
C PENETRATION SHORTWAVE RADIATION FACTOR
      XIO=0.17
C CUTOFF SNOW THICKNESS
      HCUT=0.15
C NOW DECIDE IF OPEN WATER OR ICE
      IF(KOPEN.GT.0) GO TO 51
C NOW DETERMINE OPEN WATER HEAT BUD. ASSUMING TICE=WATER TEMP.
C NOW SET ICE THICKNESS TO 1.0 FOR LATER COMPONENT CALCULATIONS
      DO 110 J=1,NY1
      DO 110 I=1,NX1
      HICE(I,J)=1.0E+00
 110  CONTINUE
C WATER ALBEDO IS ASSUMED TO BE 0.1
      DO 101 J=1,NY1
      DO 101 I=1,NX1
C MAKE OPEN WATER ALBEDO 0.2
c      ALB(I,J)=0.1E+00
      ALB(I,J)=0.2E+00
      A1(I,J)=(1-ALB(I,J))*FSH(I,J)+FLO(I,J)+D1*UG(I,J)*TAIR(I,J)
     ?+D1W*UG(I,J)*QA(I,J)
      B(I,J)=QS1*6.11E+00*EXP(17.2694E+00*(TICE(I,J)-TMELT)
     ?/(TICE(I,J)-TMELT+237.3E+00))
      A2(I,J)=-D1*UG(I,J)*TICE(I,J)-D1W*UG(I,J)*B(I,J)
     ?-D3*(TICE(I,J)**4)
 101  CONTINUE
C COMPUTE HSENS AND HLATE FOR OUTPUT
      DO J=1,NY1
      DO I=1,NX1
      HSENS(I,J)=D1*UG(I,J)*(TAIR(I,J)-TICE(I,J))
      HLATE(I,J)=D1W*UG(I,J)*(QA(I,J)-B(I,J))
      END DO
      END DO

      GO TO 52
C COME HERE IF ICE COVER
 51   CONTINUE

      ITER=0
C FIRST PUT MINIMUM ON ICE THICKNESS
      DO 102 J=1,NY1
      DO 102 I=1,NX1
      HICE(I,J)=AMAX1(HICE1(I,J),0.05E+00)
c      HICE(I,J)=AMIN1(HICE(I,J),7.0E+00)
C DO NOT CONSIDER SNOW, SET SNOW TO ZERO
      HSNO(I,J)=0.0
 102  CONTINUE
C NOW DECIDE ON ALBEDO
      DO 103 J=1,NY1
      DO 103 I=1,NX1

      ALB(I,J)=0.75E+00
      IF(TICE(I,J).GT.TMELTP) ALB(I,J)=0.66E+00
c Consider snow
c      IF(TICE(I,J).GT.TMELTP.AND.HSNO(I,J).LE.0.0) ALB(I,J)=0.66E+00
C MODIFY ALBEDO FOR SNOW COVER FROM Flato and Hibler (Ridging and strength...) 
      ASNOW=0.8E+00 
      IF(TICE(I,J).GT.TMELTP) ASNOW=0.7E+00
      IF(HSNO(I,J).GT.HCUT) THEN
      ALB(I,J)=ASNOW
      ELSE
      ALB(I,J)=ALB(I,J)+(HSNO(I,J)/HCUT)*(ASNOW-ALB(I,J))
      IF(ALB(I,J).GT.ASNOW) ALB(I,J)=ASNOW
      END IF

 103  CONTINUE
C NOW DETERMINE FIXED FORCING TERM IN HEAT BUDGE

      DO 104 J=1,NY1
      DO 104 I=1,NX1
      A1(I,J)=(1.0-ALB(I,J))*FSH(I,J)+FLO(I,J)+D1*UG(I,J)*TAIR(I,J)
     ?+D1I*UG(I,J)*QA(I,J)
 104  CONTINUE
     
C NOW COMPUTE OTHER TERMS IN HEAT BUDGET
C COME HERE AT START OF ITERATION
 60   CONTINUE
      
      DO 105 J=1,NY1
      DO 105 I=1,NX1
      B(I,J)=QS1*(C1*TICE(I,J)**4+C2*TICE(I,J)**3
     ?+C3*TICE(I,J)**2+C4*TICE(I,J)+C5)
      A2(I,J)=-D1*UG(I,J)*TICE(I,J)-D1I*UG(I,J)*B(I,J)
     ?-D3*(TICE(I,J)**4)
C SAVE HSENS AND HLATE FOR OUTPUT
      HLATE(I,J)=-D1I*UG(I,J)*B(I,J)
c Consider snow,Ks=0.31 from Parkingson and Washington
      B(I,J)=(2.1656E+00/HICE(I,J))
      A3(I,J)=4.0E+00*D3*(TICE(I,J)**3)+B(I,J)
     ?+D1*UG(I,J)
      B(I,J)=B(I,J)*(TB-TICE(I,J))
 105  CONTINUE
C SAVE HSENS AND HLATE FOR OUTPUT
      DO J=1,NY1
      DO I=1,NX1
      HSENS(I,J)=D1*UG(I,J)*(TAIR(I,J)-TICE(I,J))
      HLATE(I,J)=HLATE(I,J)+D1I*UG(I,J)*QA(I,J)
      END DO
      END DO

C NOW DECIDE IF IT IS TIME TO ESTIMATE GROWTH RATES
      IF(ITER.GE.IMAX) GO TO 52
C NOW DETERMINE NEW ICE TEMPERATURE
      DO 106 J=1,NY1
      DO 106 I=1,NX1
      TICE(I,J)=TICE(I,J)+(A1(I,J)+A2(I,J)+B(I,J))/A3(I,J)
 106  CONTINUE
C NOW DECIDE IF ITERATIONS ARE COMPLETE
      ITER=ITER+1
c      IF(ITER.LT.IMAX) GO TO 60
c      ITER=IMAX+1
C NOW SET ICE TEMP TO MIN OF TMELT/ITERATION RESULT
      DO 107 J=1,NY1
      DO 107 I=1,NX1
      TICE(I,J)=AMIN1(TICE(I,J),TMELT)
 107  CONTINUE
      GO TO 60
C COME HERE TO ESTIMATE GROWTH RATES
 52   CONTINUE
      DO 108 J=1,NY1
      DO 108 I=1,NX1
c      FICE(I,J)=Q0*(FW-A1(I,J)-A2(I,J))
      FICE(I,J)=Q0*(FW(I,J)-A1(I,J)-A2(I,J))
 108  CONTINUE
C NOW COMPILE SEPARATE HEAT BUDGET COMPONENTS
      Q0=Q0*8.64D+06

#ifdef northpole
      AAA=0.0
      DO I=2,NX1-1
      AAA=AAA+FICE(I,NY1-1)
      END DO
      AAA=AAA/FLOAT(NX1-2)
      DO I=1,NX1
      FICE(I,NY1)=AAA
      END DO

      AAA=0.0
      DO I=2,NX1-1
      AAA=AAA+TICE(I,NY1-1)
      END DO
      AAA=AAA/FLOAT(NX1-2)
      DO I=1,NX1
      TICE(I,NY1)=AAA
      END DO
#endif
#ifdef cyclic
      DO J=1,NY1
      TICE(1,J)=TICE(NX,J)
      FICE(1,J)=FICE(NX,J)
      END DO
#endif

      RETURN
      END

#else
      subroutine budget
      return
      end
c
#endif
