c====================== include file "coord.h" =========================
c
c                    model grid point coordinates
c
c     grid definition:
c
c     the model uses a staggard arakawa "b" grid which is setup and 
c     generated by the "grids.F" module. 
c
c     xt(i)   = longitude of the ith "t" point in degrees.   i=1..imt
c     xu(i)   = longitude of the ith "u,v" point in degrees. i=1..imt
c     yt(j)   = latitude of the jth "t" point in degrees.    j=1..jmt
c     yu(j)   = latitude of the jth "u,v" point in degrees.  j=1..jmt
c     zt(k)   = distance from surface down to center of level k (in cm)
c               (for depth of "t" and "u,v" grid points: k=1,km)
c     zw(k)   = distance from surface down to bottom of level k (in cm)
c               (for depth of "t" and "u,v" grid points: k=1,km)
c     dxtdeg  = widths for "t" grid cells (degrees)
c     dytdeg  = heights for "t" grid cells (degrees)
c     dxudeg  = widths for "u" grid cells (degrees)
c     dyudeg  = heights for "u" grid cells (degrees)
c     dzt(k)  = vertical resolution of "t" and "u" grid cells (in cm)
c     dzw(k)  = vertical resolution of "w" grid cells (in cm)
c
c     "i" increases in an eastward direction, "j" increases in a
c     northward direction, and "k" increases downward.
c     
      common /coord/ xt(imt), yt(jmt), xu(imt), yu(jmt), zw(km), zt(km)
      common /coord/ dxtdeg(imt), dytdeg(jmt), dzt(km)
      common /coord/ dxudeg(imt), dyudeg(jmt), dzw(0:km)
c
