#ifdef ice_model

      SUBROUTINE FORM(UICE,VICE,ETA,ZETA,DRAGS
     1,DRAGA,GAIRX,GAIRY,GWATX,GWATY,FORCEX,FORCEY,HEFF,AMASS,AREA)
#include "size.h"
#include "size_ice.h"
C PROGRAM FORMS BASIC INPUT PARAMETERS FOR RELAXATION
      DIMENSION UICE(NX1,NY1,3),VICE(NX1,NY1,3),ETA(NX1,NY1)
     1,ZETA(NX1,NY1),DRAGS(NX1,NY1),DRAGA(NX1,NY1),GAIRX(NX1,NY1)
     2,GAIRY(NX1,NY1),GWATX(NX1,NY1),GWATY(NX1,NY1),HEFF(NX1,NY1,3)
     3,FORCEX(NX1,NY1),FORCEY(NX1,NY1),AMASS(NX1,NY1)
     4,DAIRN(NX1,NY1),AREA(NX1,NY1,3)
     5,ZMAX(NX1,NY1),ZMIN(NX1,NY1)
      COMMON/STR/PRESS(NX1,NY1),ECCEN
      COMMON/OWIND/OWINX(NX1,NY1),OWINY(NX1,NY1)
      COMMON/STEP1/DELTAT,DELTAX,DELTAY
      COMMON/ARRAY/HEFFM(NX1,NY1),UVM(NX1,NY1)
      COMMON/OUTFLO/OUT(NX1,NY1)
      COMMON/COUNT/ICOUNT
      COMMON/DWATN1/DWATN(NX1,NY1),COR(NX1,NY1) 
      COMMON/ICE1/UO(NX1,NY1,2),VO(NX1,NY1,2),UOA(NX1,NY1,2)
     1,VOA(NX1,NY1,2),DPX(NX1,NY1),DPY(NX1,NY1)
      COMMON/COR1/SINEN(NX1,NY1)
      COMMON /ICEGRID/DXT(NX1),DYT(NY1),DXU(NX1),DYU(NY1)
     1       ,CST(NY1),CSU(NY1),TNGT(NY1),TNG(NY1),SINE(NY1)
C FIRST SET UP BASIC CONSTANTS
      DWAT=0.59
      DAIR=0.01462
      RHOICE=0.91D+03
      FCOR=1.46D-04
      RHOAIR=1.3
C   25 DEG GIVES SIN EQUAL TO 0.4226
      SINWIN=0.4226
      COSWIN=0.9063
      SINWAT=0.4226
      COSWAT=0.9063
      OMEGA=3.1415927/43082. 
      GRAV=9.832
      ECCEN=2.0
C 20 DEG GIVES SIN EQUAL TO .34202
C NOW SET UP MASS PER UNIT AREA AND CORIOLIS TER
      DO 101 J=1,NY
      DO 101 I=1,NX
      AMASS(I,J)=RHOICE*0.25*(HEFF(I,J,1)
     1  +HEFF(I+1,J,1)+HEFF(I,J+1,1)+HEFF(I+1,J+1,1))
      COR(I,J)=AMASS(I,J)*2.0*OMEGA*SINEN(I,J)
 101  CONTINUE
C NOW SET UP NON LINEAR WIND AND WATER DRAG
      DO 99 J=1,NY
      DO 99 I=1,NX
C STD CALCULATION
      DAIRN(I,J)=RHOAIR*.0012*SQRT(GAIRX(I,J)**2+GAIRY(I,J)**2)
C FOLLOWING CSM EQUATION
C      AAA=SQRT(GAIRX(I,J)**2+GAIRY(I,J)**2)
C      DAIRN(I,J)=RHOAIR*0.001*(2.70+0.142*AAA+0.0764*AAA*AAA)
C
      DWATN(I,J)=5.5*SQRT((UICE(I,J,1)-GWATX(I,J))**2
     1  +(VICE(I,J,1)-GWATY(I,J))**2)
      DWATN(I,J)=DMAX1(DWATN(I,J),0.25D+00)
 99   CONTINUE
C NOW SET UP SYMMETTRIC DRAG
      DO 102 J=1,NY
      DO 102 I=1,NX
      DRAGS(I,J)=DWATN(I,J)*COSWAT
 102  CONTINUE
C NOW SET UP ANTI SYMMETTRIC DRAG PLUS CORIOLIS
      DO 103 J=1,NY1
      DO 103 I=1,NX1
      IF(J.GT.51) THEN
      DRAGA(I,J)=DWATN(I,J)*SINWAT+COR(I,J)
      ELSE
      DRAGA(I,J)=DWATN(I,J)*(-SINWAT)+COR(I,J)
      END IF
 103  CONTINUE
C NOW SET UP FORCING FIELD
      DO 104 J=1,NY1
      DO 104 I=1,NX1
C FIRST DO WIND
      IF(J.GT.51) THEN
      FORCEX(I,J)=DAIRN(I,J)*(COSWIN*GAIRX(I,J)
     1  -SINWIN*GAIRY(I,J))
      FORCEY(I,J)=DAIRN(I,J)*(SINWIN*GAIRX(I,J)
     1  +COSWIN*GAIRY(I,J))
      ELSE
      FORCEX(I,J)=DAIRN(I,J)*( COSWIN*GAIRX(I,J)
     1  +SINWIN*GAIRY(I,J))
      FORCEY(I,J)=DAIRN(I,J)*(-SINWIN*GAIRX(I,J)
     1  +COSWIN*GAIRY(I,J))
      END IF

C NOW ADD IN CURRENT FORCE
      IF(J.GT.51) THEN
      FORCEX(I,J)=FORCEX(I,J)+DWATN(I,J)*(COSWAT*GWATX(I,J)
     1    -SINWAT*GWATY(I,J))
      FORCEY(I,J)=FORCEY(I,J)+DWATN(I,J)*(SINWAT*GWATX(I,J)
     1   +COSWAT*GWATY(I,J))
      ELSE
      FORCEX(I,J)=FORCEX(I,J)+DWATN(I,J)*(COSWAT*GWATX(I,J)
     1    +SINWAT*GWATY(I,J))
      FORCEY(I,J)=FORCEY(I,J)+DWATN(I,J)*(-SINWAT*GWATX(I,J)
     1   +COSWAT*GWATY(I,J))
      END IF

C NOW ADD IN TILT
      FORCEX(I,J)=FORCEX(I,J)-COR(I,J)*GWATY(I,J)
      FORCEY(I,J)=FORCEY(I,J)+COR(I,J)*GWATX(I,J)

 104  CONTINUE
 200  CONTINUE
c      WRITE(*,*) 'DPX=,UOA=', DPX(30,70),DPY(30,70),DPX(20,8),DPY(20,8)
c     &, UOA(30,70,1),VOA(30,70,1),UOA(20,8,2),VOA(20,8,2)
 2    FORMAT(1X,12G10.4/,1X,12G10.4/,1X,12G10.4/)
C NOW SET UP ICE PRESSURE AND VISCOSITIES
C FIRST SET UP CONSTANTS
      PSTAR=5.0D+03
      PSTAR=2.75D+04
      ZETAC=0.15
      ETAC=ZETAC/4.0
C NOW SET UP VALUES
      DO 105 J=1,NY1
      DO 105 I=1,NX1
      PRESS(I,J)=PSTAR*HEFF(I,J,1)*EXP(-20.0*(1.0-AREA(I,J,1)))
      ZMAX(I,J)=(5.0D+12/(2.0D+04))*PRESS(I,J)
c      ZMIN(I,J)=0.0D+00
      ZMIN(I,J)=4.0D+08
 105  CONTINUE

      CALL TEARDROP(UICE,VICE,PRESS,ETA,ZETA,ECCEN,ZMAX,ZMIN)

#ifdef northpole
      AAA=0.0
      DO I=2,NX1-1
      AAA=AAA+PRESS(I,NY1-1)
      END DO
      AAA=AAA/FLOAT(NX1-2)
      DO I=1,NX1
      PRESS(I,NY1)=AAA
      END DO
#endif
8481  CONTINUE
#ifdef cyclic
      DO J=1,NY1
      PRESS(1,J)=PRESS(NX1-1,J)
      PRESS(NX1,J)=PRESS(2,J)
      END DO
#endif

C NOW SET VISCOSITIES AND PRESSURE EQUAL TO ZERO AT OUTFLOW PTS

      DO 106 J=1,NY1
      DO 106 I=1,NX1
      PRESS(I,J)=PRESS(I,J)*OUT(I,J)
      ETA(I,J)=ETA(I,J)*OUT(I,J)
      ZETA(I,J)=ZETA(I,J)*OUT(I,J)
 106  CONTINUE
C NOW CALCULATE PRESSURE FORCE AND ADD TO EXTERNAL FORCE
      DO 107 J=1,NY
      DO 107 I=1,NX
      FORCEX(I,J)=FORCEX(I,J)-(0.25/(DXU(I)*CSU(J)))
     1  *(PRESS(I+1,J)+PRESS(I+1,J+1)-PRESS(I,J)-PRESS(I,J+1))
      FORCEY(I,J)=FORCEY(I,J)-0.25/DYU(J)
     1  *(PRESS(I,J+1)+PRESS(I+1,J+1)-PRESS(I,J)-PRESS(I+1,J))
C NOW PUT IN MINIMAL MASS FOR TIME STEPPING CALCULATIONS
 107  CONTINUE

#ifdef cyclic
      DO J=1,NY1
      FORCEX(1,J)=FORCEX(NX,J)
      FORCEY(1,J)=FORCEY(NX,J)
      FORCEX(NX1,J)=FORCEX(2,J)
      FORCEY(NX1,J)=FORCEY(2,J)
      END DO
#endif
      RETURN
      END

#else
      subroutine form
      return
      end
c
#endif
