#ifdef ice_model

      SUBROUTINE GROATB(HEFF,AREA,FHEFF,FO,YNEG,A22)
C HEAT BUDGET GROWTH SUB. FOR TWO LEVEL MODEL
#include "size.h"
#include "size_ice.h"
      DIMENSION HEFF(NX1,NY1,3),AREA(NX1,NY1,3),FHEFF(NX1,NY1)
     1,FO(NX1,NY1),HICE(NX1,NY1),AR(NX1,NY1)
     2,YNEG(NX1,NY1)
c  The next sentence is for 7 thickness strips
      COMMON/SEV/TICES(NX1,NY1,7),FHEFP(NX1,NY1),HICEP(NX1,NY1)
      COMMON/ARRAY/HEFFM(NX1,NY1),UVM(NX1,NY1)
      COMMON/DAY/IDELT,NSTEPS
      COMMON/BUD/TAIR(NX1,NY1),QA(NX1,NY1),FLO(NX1,NY1)
     1,FSH(NX1,NY1),UG(NX1,NY1)
      COMMON/MIX/TMIX(NX1,NY1),TICE(NX1,NY1)
      COMMON/COUNT/ICOUNT
      COMMON/GWIND/GAIRX(NX1,NY1),GAIRY(NX1,NY1)
      COMMON/PBLHEAT/HSENS(NX1,NY1),HLATE(NX1,NY1)
      DIMENSION HSENSP(NX1,NY1),HLATEP(NX1,NY1)
      DIMENSION HSENS0(NX1,NY1),HLATE0(NX1,NY1)
#include "levind.h"
C INVERSE OF MIXED LAYER DEPTH (FIRST LEVEL OF OCEAN MODEL)
      HMIXI=1.0E+00/12.0E+00
C DETERMINE AMOUNT OF OPEN WATER AND ICE THICKNESS
      DO 101 J=1,NY1
      DO 101 I=1,NX1
      AREA(I,J,2)=DMAX1(A22,AREA(I,J,2))
      FHEFF(I,J)=0.0
      HSENS(I,J)=0.0
      HLATE(I,J)=0.0
      HICE(I,J)=HEFF(I,J,2)/AREA(I,J,2)
      AR(I,J)=DMIN1(AREA(I,J,2),HEFF(I,J,2)*1.0D+04)
 101  CONTINUE
C NOW DETERMINE MIXED LAYER TEMPERATURE
      DO 102 J=1,NY1
      DO 102 I=1,NX1
C MODIFY NEXT STATEMENT FOR COUPLING TO OCEAN MODEL
      TMIX(I,J)=72.0764E+00*HMIXI*YNEG(I,J)+271.2E+00
 102  CONTINUE

C NOW READ ALL THERMO VARIABLES IN  (SINGLE PRECISION)   
c      IF(MOD(ICOUNT,IDELT).NE.1) GO TO 256
      IF(MOD(ICOUNT,5*IDELT).NE.1) GO TO 256

      read(99) ((tair(i,j),i=1,NX1),j=1,NY1)
      read(99) ((qa(i,j),i=1,NX1),j=1,NY1)
      read(99) ((flo(i,j),i=1,NX1),j=1,NY1)
      read(99) ((fsh(i,j),i=1,NX1),j=1,NY1)

c      WRITE(*,'(7e11.4)') (TAIR(20,J),J=1,JMT,10)
c      WRITE(*,'(7e11.4)') (QA(20,J),J=1,JMT,10)
c      WRITE(*,'(7e11.4)') (FLO(20,J),J=1,JMT,10)
c      WRITE(*,'(7e11.4)') (FSH(20,J),J=1,JMT,10)

        do 52 i=1,nx1
        do 52 j=1,ny1
c consider emissivity
        flo(i,j)=0.97*flo(i,j)
c ncep shortwave radiation is 10% large than other sources
        fsh(i,j)=0.90*fsh(i,j)
52      continue

      DO 202 J=2,NY
      DO 202 I=2,NX
      U1=0.25*(GAIRX(I-1,J-1)+GAIRX(I-1,J)
     1+GAIRX(I,J-1)+GAIRX(I,J))
      V1=0.25*(GAIRY(I-1,J-1)+GAIRY(I-1,J)
     1+GAIRY(I,J-1)+GAIRY(I,J))
      UG(I,J)=SQRT(U1*U1+V1*V1)
 202  CONTINUE

      PRINT 5,ICOUNT,ICOUNT/IDELT
 5    FORMAT(1X,'THERMO DATA READ IN,  TIMESTEP & DAY =',2i10)
      write(*,'(4e12.4)')
     &TAIR(IMT/2,JMT-1),QA(IMT/2,JMT-1)
     &,FLO(IMT/2,JMT-1),FSH(IMT/2,JMT-1)
 256  CONTINUE

C NOW DETERMINE GROWTH RATES
C FIRST DO OPEN WATER
      KOPEN=-1
      CALL BUDGET(TMIX,HICE,FO,HSENS0,HLATE0,KOPEN)
C NOW DO ICE
      KOPEN=1
c  The next sentence is commented for 7 thickness strips
c      CALL BUDGET(TICE,HICE,FHEFF,KOPEN)
c  The next paragraph is added for 7 thickness strips
      DO 105 IT=1,7
      DO 104 J=1,NY1
      DO 104 I=1,NX1
      RK=IT*1.0
      HICEP(I,J)=(HICE(I,J)/7.0)*((2*RK)-1.0)
      TICE(I,J)=TICES(I,J,IT)
104   CONTINUE
      CALL BUDGET(TICE,HICEP,FHEFP,HSENSP,HLATEP,KOPEN)
      DO 106 J=1,NY1
      DO 106 I=1,NX1
      FHEFF(I,J)=(FHEFP(I,J)/7.0)+FHEFF(I,J)
      HSENS(I,J)=(HSENSP(I,J)/7.0)+HSENS(I,J)
      HLATE(I,J)=(HLATEP(I,J)/7.0)+HLATE(I,J)
      TICES(I,J,IT)=TICE(I,J)
106   CONTINUE
105   CONTINUE

C NOW GET TOTAL GROWTH RATE
      DO 103 J=1,NY1
      DO 103 I=1,NX1
      FHEFF(I,J)=FHEFF(I,J)*AR(I,J)+(1.0D+00-AR(I,J))*FO(I,J)
      HSENS(I,J)=HSENS(I,J)*AR(I,J)+(1.0D+00-AR(I,J))*HSENS0(I,J)
      HLATE(I,J)=HLATE(I,J)*AR(I,J)+(1.0D+00-AR(I,J))*HLATE0(I,J)
 103  CONTINUE

c      WRITE(*,'(I8,5e11.4)') ICOUNT,TAIR(50,73),QA(50,73),FLO(50,73)
c     &,FSH(50,73),UG(50,73)
c      WRITE(*,'(8e10.3)') TMIX(50,73),(TICES(50,73,IT),IT=1,7)
c      WRITE(*,'(2f10.3)') HEFF(50,73,1),AREA(50,73,1)
c      WRITE(*,'(2f15.6)') FHEFF(50,73),FO(50,73)

      RETURN
      END

#else
      subroutine groatb
      return
      end
c
#endif
