#ifdef ice_model

      SUBROUTINE GROWTH(HEFF,AREA,FH,HO,A22)
C SUBROUTINE TO CALCULATE CHANGE OF PARAMETERS DUE TO GROWTH
#include "size.h"
#include "size_ice.h"
C  THIS SUBROUTINE MUST BE CALLED AFTER ADVECTION
C FH IS ADDITION MELTING THAT MUST BE DONE TO BALANCE MIXED LAYER
      DIMENSION HEFF(NX1,NY1,3),AREA(NX1,NY1,3),GHEFF(NX1,NY1)
     1,GAREA(NX1,NY1),H(NX1,NY1),FH(NX1,NY1)
      COMMON/RATE/FHEFF(NX1,NY1),FO(NX1,NY1)
      COMMON/STEP1/DELTAT,DELTAX,DELTAY
      COMMON/ARRAY/HEFFM(NX1,NY1),UVM(NX1,NY1)
      COMMON/OUTFLO/OUT(NX1,NY1)
      COMMON/NEG/YNEG(NX1,NY1)
      COMMON/COUNT/ICOUNT
      COMMON/DAY/IDELT,NSTEPS
      COMMON/S1/SALT(NX1,NY1)
      COMMON/RIV/RIVER(NX1,NY1),RAIN(NX1,NY1)
      COMMON/NET1/HGROW(NX1,NY1)
      COMMON/SNOW/HSNO(NX1,NY1)
      COMMON/WATER1/WATR(NX1,NY1)
      COMMON/FW1/FW(NX1,NY1)

      ZERO=0.0
      ONE=1.0
      IF(A22.LT.0) GO TO 210
C FIRST SOLVE FOR THICKNESS OF THICK ICE
      DO 101 J=1,NY1
      DO 101 I=1,NX1
      AREA(I,J,2)=MAX(A22,AREA(I,J,2))
      H(I,J)=HEFF(I,J,2)/AREA(I,J,2)
 101  CONTINUE

C READ SNOWFALL AND OCEANIC HEAT FLUX
      IF(MOD(ICOUNT,31*IDELT).NE.1) GO TO 1256
c no info for snow; do not consider snow here
c      READ(97) ((RAIN(I,J),I=1,NX1),J=1,NY1)
      READ(95) ((FW(I,J),I=1,NX1),J=1,NY1)
      DO J=1,NY1
      DO I=1,NX1
c change sign of oceanic heat flux
      FW(I,J)=-FW(I,J)
c no info for oceanic heat flux, specify
c      FW(I,J)=-2.0
      END DO
      END DO
1256  CONTINUE

C GROWTH SUBROUTINE CALCULATES TOTAL GROWTH TENDENCIES INCLUDING SNOWFALL
      CALL GROATB(HEFF,AREA,FHEFF,FO,YNEG,A22)
 1    FORMAT(1X,11G11.5)
C NOW CALCULATE CORRECTED GROWTH
      DO 201 J=1,NY1
      DO 201 I=1,NX1
      GHEFF(I,J)=-DELTAT*FHEFF(I,J)
      GAREA(I,J)=DELTAT*FO(I,J)
 201  CONTINUE
      DO 102 J=1,NY1
      DO 102 I=1,NX1
      GHEFF(I,J)=-1.0*DMIN1(HEFF(I,J,1),GHEFF(I,J))
      GAREA(I,J)=DMAX1(ZERO,GAREA(I,J))
 102  CONTINUE
      DO 103 J=1,NY1
      DO 103 I=1,NX1
      FH(I,J)=DMIN1(ZERO,GHEFF(I,J))
 103  CONTINUE
C NOW DO AREA CHANGE
      DO 104 J=1,NY1
      DO 104 I=1,NX1
      GAREA(I,J)=2.0*(1.0-AREA(I,J,2))*GAREA(I,J)/HO
     1+.5*FH(I,J)*AREA(I,J,2)/(HEFF(I,J,1)+.00001)
 104  CONTINUE
C NOW CORRECT AREA AND HEFF(I,J,1)
      DO 105 J=1,NY1
      DO 105 I=1,NX1
      AREA(I,J,1)=AREA(I,J,1)+GAREA(I,J)
      HEFF(I,J,1)=HEFF(I,J,1)+GHEFF(I,J)*OUT(I,J)
C THE NEXT ICE GROWTH RATE INCLUDES RAIN FALL ON WHERE IT IS FREEZING
      HGROW(I,J)=GHEFF(I,J)
 105  CONTINUE
C NOW CALCULATE ADDITIONAL ICE TO BE MELTED FOR MIX. LAY. BALANCE
      DO 111 J=1,NY1
      DO 111 I=1,NX1
      FH(I,J)=GHEFF(I,J)-DELTAT*FHEFF(I,J)
 111  CONTINUE
      CALL RNEGT(HEFF,YNEG,FH)
C NOW ZERO OUTSIDE POINTS
      GO TO 211
 210  CONTINUE
      A22=-A22
      DO 109 J=1,NY1
      DO 109 I=1,NX1
      AREA(I,J,1)=AREA(I,J,1)*HEFFM(I,J)
C MODIFICATION FOR ONE LEVEL CASE
      HEFF(I,J,1)=HEFF(I,J,1)*HEFFM(I,J)
 109  CONTINUE
C NOW SET AREA(I,J,1)=0 WHERE NO ICE IS
      DO 110 J=1,NY1
      DO 110 I=1,NX1
      AREA(I,J,1)=DMIN1(AREA(I,J,1),HEFF(I,J,1)/.0001)
 110  CONTINUE
C NOW TRUNCATE AREA
      DO 106 J=1,NY1
      DO 106 I=1,NX1
      AREA(I,J,1)=DMIN1(ONE,AREA(I,J,1))
      AREA(I,J,1)=DMAX1(ZERO,AREA(I,J,1))
 106  CONTINUE
C NOW CALCULATE ADDITIONAL ICE TO BE MELTED FOR MIXED LAYER BALANCE
      DO 108 J=1,NY1
      DO 108 I=1,NX1
C NOW STORE COMMON GROWTH RATE
      FHEFF(I,J)=DELTAT*FHEFF(I,J)
 108  CONTINUE
 211  CONTINUE
      RETURN
      END

#else
      subroutine growth
      return
      end
c
#endif
