      subroutine kmtbc (kmt, imt, jmt)
c
c-----------------------------------------------------------------------
c     set lateral boundary conditions on kmt
c     set cyclic, solid wall and symmetry conditions on "t" grid
c-----------------------------------------------------------------------
c
      dimension kmt(imt,jmt)
c
#ifdef cyclic
c
c     set cyclic conditions on eastern and western boundary
c
      do jrow=1,jmt
        kmt(1,jrow)   = kmt(imt-1,jrow)
        kmt(imt,jrow) = kmt(2,jrow)
      enddo
#else
c
c     set solid wall conditions on eastern and western boundary
c     (if "cyclic" is not enabled then option "solid_walls" is assumed)
c
      do jrow=1,jmt
# ifdef obc_west
        kmt(1,jrow)   = kmt(2,jrow)
# else	
        kmt(1,jrow)   = 0
# endif
# ifdef obc_east
        kmt(imt,jrow) = kmt(imt-1,jrow)
# else	
        kmt(imt,jrow) = 0
# endif
      enddo
#endif
#if defined symmetry || defined obc_north
c
c     set symmetry conditions at "u" row jmt-1
c     or extrapolate the domain to the northernmost row
c
      do i=1,imt
        kmt(i,jmt) = kmt(i,jmt-1)
      enddo
#else
# ifdef northpole
c
c do nothing
      do i=1,imt
        kmt(i,jmt) = kmt(imt/2,jmt)
      enddo
c northpole debug
c      do i=1,imt
c        print *, 'kmt(i,jmt)',i,kmt(i,jmt)
c      enddo
c
# else
c
c     close the domain at the northernmost row
c
      do i=1,imt
        kmt(i,jmt) = 0
      enddo
# endif
#endif
# ifdef obc_south
c
c     extrapolate the domain to the southernmost row
c
      do i=1,imt
        kmt(i,1)   = kmt(i,2)
      enddo
# else
c
c     close the domain at the southernmost row
c
      do i=1,imt
        kmt(i,1)   = 0
      enddo
# endif
      return
      end

