#ifdef ice_model
C*****************************************************************************
C PLEASE KEEP THIS NOTE OF MODEL-DEVELOPMENT HISTORY
C Matrix solve uses Thomas algorithm, 10/1991, Jinlun Zhang  
C Spherical coordinate system, 10/27/93, Jinlun Zhang
C Latest finite differencing scheme for treatment of NP,9/9/1996,Jinlun Zhang
C Alternating direction implicit (ADI) method is used, 10/1998, Jinlun Zhang
C For details about ADI dynamics model, see Zhang and Rothrock, "Modeling
C   Arctic Sea ice with an efficient plastic solution", submitted to JGR, 1999
C*****************************************************************************
      SUBROUTINE RELAX(UICE,VICE,ETA,ZETA,DRAGS,DRAGA
     1,AMASS,FORCEX,FORCEY,ERROR,UICEC,VICEC)
#include "size.h"
#include "size_ice.h"
      DIMENSION UICE(NX1,NY1,3),VICE(NX1,NY1,3),ETA(NX1,NY1)
     1,ZETA(NX1,NY1)
     1,DRAGS(NX1,NY1),DRAGA(NX1,NY1),FORCEX(NX1,NY1),FORCEY(NX1,NY1)
     2,AMASS(NX1,NY1)
     5,UICEC(NX1,NY1),VICEC(NX1,NY1)
     6,AU(NX1,NY1),BU(NX1,NY1),CU(NX1,NY1),URT(NX1)
     6,AV(NX1,NY1),BV(NX1,NY1),CV(NX1,NY1),VRT(NY1)
     6,FXY(NX1,NY1),FXY1(NX1,NY1),CUU(NX1),CVV(NY1)
      COMMON/OWIND/OWINX(NX1,NY1),OWINY(NX1,NY1)
      COMMON/WIND/WINDX(NX1,NY1),WINDY(NX1,NY1)
      COMMON/DAY/IDELT,NSTEPS
      COMMON/STEP1/DELTAT,DELTAX,DELTAY
      COMMON/ARRAY/HEFFM(NX1,NY1),UVM(NX1,NY1)
      COMMON/COUNT/ICOUNP
      COMMON /ICEGRID/DXT(NX1),DYT(NY1),DXU(NX1),DYU(NY1)
     1       ,CST(NY1),CSU(NY1),TNGT(NY1),TNG(NY1),SINE(NY1)

      RADIUS=6370.E3

#ifdef northpole
      NYPOLE=NY
      NPOL=1
#else
      NYPOLE=NYM1
      NPOL=0
#endif
c
#ifdef cyclic
      NXLCYC=NX
      LCYC=1
#else
      NXLCYC=NXM1
      LCYC=0
#endif
      DO J=1,NY1
      DO I=1,NX1
      FORCEX(I,J)=FORCEX(I,J)*UVM(I,J)
      FORCEY(I,J)=FORCEY(I,J)*UVM(I,J)
      END DO
      END DO
C MUST UPDATE HEFF BEFORE CALLING RELAC
C FIRST SET U(2)=U(1)
      DO 99 J=1,NY1
      DO 99 I=1,NX1
C NOW MAKE SURE BDRY PTS ARE EQUAL TO ZERO
      UICE(I,J,2)=UICE(I,J,1)
      VICE(I,J,2)=VICE(I,J,1)
      UICE(I,J,1)=UICE(I,J,3)*UVM(I,J)
      VICE(I,J,1)=VICE(I,J,3)*UVM(I,J)
 99   CONTINUE
 501  CONTINUE

#ifdef northpole
      DO I=1,NX1/2
      UICE(I,NY+1,1)=-UICEC(I+(NX1-2)/2,NY)
      VICE(I,NY+1,1)=-VICEC(I+(NX1-2)/2,NY)
      UICE(I,NY+1,3)=-UICEC(I+(NX1-2)/2,NY)
      VICE(I,NY+1,3)=-VICEC(I+(NX1-2)/2,NY)

      UICEC(I,NY+1)=-UICEC(I+(NX1-2)/2,NY)
      VICEC(I,NY+1)=-VICEC(I+(NX1-2)/2,NY)
      END DO

      DO I=NX1/2+1,NX
      UICE(I,NY+1,1)=-UICEC(I-(NX1-2)/2,NY)
      VICE(I,NY+1,1)=-VICEC(I-(NX1-2)/2,NY)
      UICE(I,NY+1,3)=-UICEC(I-(NX1-2)/2,NY)
      VICE(I,NY+1,3)=-VICEC(I-(NX1-2)/2,NY)

      UICEC(I,NY+1)=-UICEC(I-(NX1-2)/2,NY)
      VICEC(I,NY+1)=-VICEC(I-(NX1-2)/2,NY)
      END DO
#endif

#ifdef cyclic
      DO J=1,NY1
      UICE(1,J,1)=UICEC(NX,J)
      VICE(1,J,1)=VICEC(NX,J)
      UICE(NX1,J,1)=UICEC(2,J)
      VICE(NX1,J,1)=VICEC(2,J)
      UICE(1,J,3)=UICEC(NX,J)
      VICE(1,J,3)=VICEC(NX,J)
      UICE(NX1,J,3)=UICEC(2,J)
      VICE(NX1,J,3)=VICEC(2,J)

      UICEC(1,J)=UICEC(NX,J)
      VICEC(1,J)=VICEC(NX,J)
      UICEC(NX1,J)=UICEC(2,J)
      VICEC(NX1,J)=VICEC(2,J)
      END DO
#endif

1413  FORMAT(2I4,6E12.4)

C FIRST DO UICE
C THE FIRST HALF

      DO J=2,NYPOLE
      DO I=2,NXLCYC
      DELXY=0.5/(DXU(I)*DYU(J))
      DELXR=0.5/(DXU(I)*RADIUS)
      DELX2=0.5/(DXU(I)*DXU(I))
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      ZETAMEAN=0.25*(ZETA(I,J+1)+ZETA(I+1,J+1)+ZETA(I,J)+ZETA(I+1,J))

      FXY(I,J)=DRAGA(I,J)*VICEC(I,J)+FORCEX(I,J)
     3+0.5*(ZETA(I+1,J+1)*(VICEC(I+1,J+1)+VICEC(I,J+1)
     3-VICEC(I+1,J)-VICEC(I,J))+ZETA(I+1,J)*(VICEC(I+1,J)
     3+VICEC(I,J)-VICEC(I+1,J-1)-VICEC(I,J-1))+ZETA(I,J+1)
     3*(VICEC(I,J)+VICEC(I-1,J)-VICEC(I,J+1)-VICEC(I-1,J+1))
     3+ZETA(I,J)*(VICEC(I,J-1)+VICEC(I-1,J-1)-VICEC(I,J)
     3-VICEC(I-1,J)))*DELXY/CSU(J)
     3
     4-0.5*(ETA(I+1,J+1)*(VICEC(I+1,J+1)+VICEC(I,J+1)
     4-VICEC(I+1,J)-VICEC(I,J))+ETA(I+1,J)*(VICEC(I+1,J)
     4+VICEC(I,J)-VICEC(I+1,J-1)-VICEC(I,J-1))+ETA(I,J+1)
     4*(VICEC(I,J)+VICEC(I-1,J)-VICEC(I,J+1)-VICEC(I-1,J+1))
     4+ETA(I,J)*(VICEC(I,J-1)+VICEC(I-1,J-1)-VICEC(I,J)
     4-VICEC(I-1,J)))*DELXY/CSU(J)
     4
     5+0.5*(VICEC(I+1,J)-VICEC(I-1,J))*(ETA(I,J+1)+ETA(I+1,J+1)
     5-ETA(I,J)-ETA(I+1,J))*DELXY/CSU(J)+0.5*ETAMEAN*((VICEC(I+1,J+1)
     5-VICEC(I-1,J+1))/CSU(J+1)-(VICEC(I+1,J-1)-VICEC(I-1,J-1))
     5/CSU(J-1))*DELXY
     5
     6-((ZETA(I+1,J+1)+ZETA(I+1,J)-ZETA(I,J)-ZETA(I,J+1))
     6+(ETA(I+1,J+1)+ETA(I+1,J)-ETA(I,J)-ETA(I,J+1)))
     6*TNG(J)*VICEC(I,J)*DELXR/CSU(J)
     6-(ETAMEAN+ZETAMEAN)*TNG(J)*(VICEC(I+1,J)-VICEC(I-1,J))
     6*DELXR/CSU(J)
     6
     7-ETAMEAN*2.0*TNG(J)*(VICEC(I+1,J)-VICEC(I-1,J))*DELXR/CSU(J)

      END DO
      END DO

c      print *, 'FXY for UICE  '
c      print 15, (FXY(20,J),J=1,JMT)

      DO J=2,NYPOLE
      DO I=2,NXLCYC
      DELX2=0.5/(DXU(I)*DXU(I))
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      RADIUS2=1.0/(RADIUS*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      AA1=((ETA(I+1,J)+ZETA(I+1,J))/CSU(J)+(ETA(I+1,J+1)+ZETA(I+1,J+1))
     &     /CSU(J))/CSU(J)
      AA2=((ETA(I,J)+ZETA(I,J))/CSU(J)+(ETA(I,J+1)+ZETA(I,J+1))
     &     /CSU(J))/CSU(J)
      AA3=ETA(I,J+1)+ETA(I+1,J+1)
      AA4=ETA(I,J)+ETA(I+1,J)
      AA5=-(ETA(I,J+1)+ETA(I+1,J+1)-ETA(I,J)-ETA(I+1,J))*TNG(J)
      AA6=2.0*ETAMEAN*TNG(J)*TNG(J)
      AU(I,J)=-AA2*DELX2*UVM(I,J)
      BU(I,J)=((AA1+AA2)*DELX2+AA6*RADIUS2
     &+AMASS(I,J)/DELTAT*2.0+DRAGS(I,J))*UVM(I,J)+(1.0-UVM(I,J))
      CU(I,J)=-AA1*DELX2*UVM(I,J)
      END DO
      END DO
      DO J=2,NYPOLE
      AU(2,J)=0.0
      CU(NXLCYC,J)=0.0
      CU(2,J)=CU(2,J)/BU(2,J)
      END DO

      DO 1200 J=2,NYPOLE
      DO I=2,NXLCYC

      DELX2=0.5/(DXU(I)*DXU(I))
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))

      AA1=((ETA(I+1,J)+ZETA(I+1,J))/CSU(J)+(ETA(I+1,J+1)+ZETA(I+1,J+1))
     &     /CSU(J))/CSU(J)
      AA2=((ETA(I,J)+ZETA(I,J))/CSU(J)+(ETA(I,J+1)+ZETA(I,J+1))
     &     /CSU(J))/CSU(J)
      AA3=ETA(I,J+1)+ETA(I+1,J+1)
      AA4=ETA(I,J)+ETA(I+1,J)
      AA5=-(ETA(I,J+1)+ETA(I+1,J+1)-ETA(I,J)-ETA(I+1,J))*TNG(J)
      AA6=2.0*ETAMEAN*TNG(J)*TNG(J)

      IF(I.EQ.2) THEN
      AA9=AA2*DELX2*UICEC(I-1,J)*UVM(I,J)*FLOAT(LCYC-0)
      ELSE IF(I.EQ.NXLCYC) THEN
      AA9=AA1*DELX2*UICEC(I+1,J)*UVM(I,J)*FLOAT(LCYC-0)
      ELSE
      AA9=0.0
      END IF

      URT(I)=AA9+FXY(I,J)-AA5*DELYR*UICE(I,J,2)
     1-(AA3+AA4)*DELY2*UICE(I,J,2)
     1+(ETA(I,J+1)+ETA(I+1,J+1))*UICE(I,J+1,2)*DELY2
     2+(ETA(I,J)+ETA(I+1,J))*UICE(I,J-1,2)*DELY2
     3+ETAMEAN*DELYR*(UICE(I,J+1,2)*TNG(J+1)-UICE(I,J-1,2)*TNG(J-1))
     4-ETAMEAN*DELYR*2.0*TNG(J)*(UICE(I,J+1,2)-UICE(I,J-1,2))
      URT(I)=(URT(I)+AMASS(I,J)/DELTAT*UICE(I,J,2)*2.0)*UVM(I,J)
      END DO

      DO I=2,NXLCYC
      CUU(I)=CU(I,J)
      END DO
      URT(2)=URT(2)/BU(2,J)
      DO I=3,NXLCYC
      IM=I-1
      CUU(I)=CUU(I)/(BU(I,J)-AU(I,J)*CUU(IM))
      URT(I)=(URT(I)-AU(I,J)*URT(IM))/(BU(I,J)-AU(I,J)*CUU(IM))
      END DO
      DO I=1,NXLCYC-2
      J1=NXLCYC-I
      J2=J1+1
      URT(J1)=URT(J1)-CUU(J1)*URT(J2)
      END DO
      DO I=2,NXLCYC
      UICE(I,J,1)=URT(I)
      END DO
1200  CONTINUE

c      print *, 'UICE 1st  '
c      print 15, (UICE(20,J,1),J=1,JMT)
      DO I=2,NXLCYC
      DO J=2,NYPOLE
      UICE(I,J,3)=UICE(I,J,1)
      END DO
      END DO

C NOW THE SECOND HALF
      DO I=2,NXLCYC
      DO J=2,NYPOLE
      DELX2=0.5/(DXU(I)*DXU(I))
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      RADIUS2=1.0/(RADIUS*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      ZETAMEAN=0.25*(ZETA(I,J+1)+ZETA(I+1,J+1)+ZETA(I,J)+ZETA(I+1,J))

      AA1=ETA(I,J+1)+ETA(I+1,J+1)
      AA2=ETA(I,J)+ETA(I+1,J)
      AA5=-(ETA(I,J+1)+ETA(I+1,J+1)-ETA(I,J)-ETA(I+1,J))*TNG(J)
      AA6=2.0*ETAMEAN*TNG(J)*TNG(J)
      
      AV(I,J)=(-AA2*DELY2+ETAMEAN*DELYR*(TNG(J-1)-2.0*TNG(J)))*UVM(I,J)
      BV(I,J)=((AA1+AA2)*DELY2+AA5*DELYR+AA6*RADIUS2
     &+AMASS(I,J)/DELTAT*2.0+DRAGS(I,J))*UVM(I,J)+(1.0-UVM(I,J))
      CV(I,J)=(-AA1*DELY2-ETAMEAN*DELYR*(TNG(J+1)-2.0*TNG(J)))*UVM(I,J)
      END DO
      END DO
      DO I=2,NXLCYC
      AV(I,2)=0.0
      CV(I,NYPOLE)=0.0
      CV(I,2)=CV(I,2)/BV(I,2)
      END DO

      DO I=2,NXLCYC
      DO J=2,NYPOLE
      DELX2=0.5/(DXU(I)*DXU(I))
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      RADIUS2=1.0/(RADIUS*RADIUS)

      AA1=((ETA(I+1,J)+ZETA(I+1,J))/CSU(J)+(ETA(I+1,J+1)+ZETA(I+1,J+1))
     &     /CSU(J))/CSU(J)
      AA2=((ETA(I,J)+ZETA(I,J))/CSU(J)+(ETA(I,J+1)+ZETA(I,J+1))
     &     /CSU(J))/CSU(J)

      IF(J.EQ.NYPOLE) THEN
      AA9=( (ETA(I,J+1)+ETA(I+1,J+1))*DELY2*UICEC(I,J+1) 
     &     +ETAMEAN*DELYR*(TNG(J+1)-2.0*TNG(J))*UICEC(I,J+1) )*UVM(I,J)
     &*FLOAT(NPOL-0)
      ELSE
      AA9=0.0
      END IF

      FXY1(I,J)=AA9+AMASS(I,J)/DELTAT*UICE(I,J,1)*2.0
     5-(AA1+AA2)*DELX2*UICE(I,J,1)
     6+((ETA(I+1,J)+ZETA(I+1,J)+ETA(I+1,J+1)+ZETA(I+1,J+1))
     6*UICE(I+1,J,1)
     6+(ETA(I,J)+ZETA(I,J)+ETA(I,J+1)+ZETA(I,J+1))*UICE(I-1,J,1))
     6*DELX2/CSU(J)/CSU(J)
      
      END DO
      END DO

      DO 1300 I=2,NXLCYC
      DO J=2,NYPOLE
      VRT(J)=FXY(I,J)+FXY1(I,J)
      VRT(J)=VRT(J)*UVM(I,J)
      END DO

      DO J=2,NYPOLE
      CVV(J)=CV(I,J)
      END DO
      VRT(2)=VRT(2)/BV(I,2)
      DO J=3,NYPOLE
      JM=J-1
      CVV(J)=CVV(J)/(BV(I,J)-AV(I,J)*CVV(JM))
      VRT(J)=(VRT(J)-AV(I,J)*VRT(JM))/(BV(I,J)-AV(I,J)*CVV(JM))
      END DO
      DO J=1,NYPOLE-2
      J1=NYPOLE-J
      J2=J1+1
      VRT(J1)=VRT(J1)-CVV(J1)*VRT(J2)
      END DO
      DO J=2,NYPOLE
      UICE(I,J,1)=VRT(J)
      END DO
1300  CONTINUE

c      print *, 'UICE 2st  '
c      print 15, (UICE(20,J,1),J=1,JMT)


C NOW DO VICE
C THE FIRST HALF

      DO I=2,NXLCYC
      DO J=2,NYPOLE
      DELXY=0.5/(DXU(I)*DYU(J))
      DELXR=0.5/(DXU(I)*RADIUS)
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      ZETAMEAN=0.25*(ZETA(I,J+1)+ZETA(I+1,J+1)+ZETA(I,J)+ZETA(I+1,J))
  
      FXY(I,J)=-DRAGA(I,J)*UICEC(I,J)+FORCEY(I,J)
     3+(0.5*(UICEC(I+1,J)-UICEC(I-1,J))*(ZETA(I,J+1)+ZETA(I+1,J+1)
     3-ZETA(I,J)-ZETA(I+1,J))*DELXY/CSU(J)+0.5*ZETAMEAN*((UICEC(I+1,J+1)
     3-UICEC(I-1,J+1))/CSU(J+1)-(UICEC(I+1,J-1)-UICEC(I-1,J-1))
     3/CSU(J-1))*DELXY)
     3
     4-(0.5*(UICEC(I+1,J)-UICEC(I-1,J))*(ETA(I,J+1)+ETA(I+1,J+1)
     4-ETA(I,J)-ETA(I+1,J))*DELXY/CSU(J)+0.5*ETAMEAN*((UICEC(I+1,J+1)
     4-UICEC(I-1,J+1))/CSU(J+1)-(UICEC(I+1,J-1)-UICEC(I-1,J-1))
     4/CSU(J-1))*DELXY)
     4
     5+0.5*(ETA(I+1,J+1)*(UICEC(I+1,J+1)+UICEC(I,J+1)
     5-UICEC(I+1,J)-UICEC(I,J))+ETA(I+1,J)*(UICEC(I+1,J)
     5+UICEC(I,J)-UICEC(I+1,J-1)-UICEC(I,J-1))+ETA(I,J+1)
     5*(UICEC(I,J)+UICEC(I-1,J)-UICEC(I,J+1)-UICEC(I-1,J+1))
     5+ETA(I,J)*(UICEC(I,J-1)+UICEC(I-1,J-1)-UICEC(I,J)
     5-UICEC(I-1,J)))*DELXY/CSU(J)
     5
     6+(ETA(I+1,J+1)+ETA(I+1,J)-ETA(I,J)-ETA(I,J+1))
     6*TNG(J)*UICEC(I,J)*DELXR/CSU(J)
     6+ETAMEAN*TNG(J)*(UICEC(I+1,J)-UICEC(I-1,J))*DELXR/CSU(J)
     6
     7+ETAMEAN*2.0*TNG(J)*(UICEC(I+1,J)-UICEC(I-1,J))*DELXR/CSU(J)

      END DO
      END DO

c      print *, 'FXY for VICE  '
c      print 15, (FXY(20,J),J=1,JMT)

      DO I=2,NXLCYC
      DO J=2,NYPOLE
      DELX2=0.5/(DXU(I)*DXU(I))
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      RADIUS2=1.0/(RADIUS*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      ZETAMEAN=0.25*(ZETA(I,J+1)+ZETA(I+1,J+1)+ZETA(I,J)+ZETA(I+1,J))
      AA1=ETA(I,J+1)+ZETA(I,J+1)+ETA(I+1,J+1)+ZETA(I+1,J+1)
      AA2=ETA(I,J)+ZETA(I,J)+ETA(I+1,J)+ZETA(I+1,J)
      AA3=(ETA(I+1,J)/CSU(J)+ETA(I+1,J+1)/CSU(J))/CSU(J)
      AA4=(ETA(I,J)/CSU(J)+ETA(I,J+1)/CSU(J))/CSU(J)
      AA5=((ZETA(I,J+1)-ETA(I,J+1))+(ZETA(I+1,J+1)-ETA(I+1,J+1))
     &-(ZETA(I,J)-ETA(I,J))-(ZETA(I+1,J)-ETA(I+1,J)))*TNG(J)
      AA6=2.0*ETAMEAN*TNG(J)*TNG(J)

      AV(I,J)=(-AA2*DELY2-(ZETAMEAN-ETAMEAN)*TNG(J-1)*DELYR
     &-ETAMEAN*2.0*TNG(J)*DELYR)*UVM(I,J)
      BV(I,J)=((AA1+AA2)*DELY2+AA5*DELYR+AA6*RADIUS2
     &+AMASS(I,J)/DELTAT*2.0+DRAGS(I,J))*UVM(I,J)+(1.0-UVM(I,J))
      CV(I,J)=(-AA1*DELY2+(ZETAMEAN-ETAMEAN)*TNG(J+1)*DELYR
     &+ETAMEAN*2.0*TNG(J)*DELYR)*UVM(I,J)
      END DO
      END DO
      DO I=2,NXLCYC
      AV(I,2)=0.0
      CV(I,NYPOLE)=0.0
      CV(I,2)=CV(I,2)/BV(I,2)
      END DO

      DO 1301 I=2,NXLCYC
      DO J=2,NYPOLE
      DELX2=0.5/(DXU(I)*DXU(I))
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      RADIUS2=1.0/(RADIUS*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      ZETAMEAN=0.25*(ZETA(I,J+1)+ZETA(I+1,J+1)+ZETA(I,J)+ZETA(I+1,J))

      AA1=ETA(I,J+1)+ZETA(I,J+1)+ETA(I+1,J+1)+ZETA(I+1,J+1)
      AA2=ETA(I,J)+ZETA(I,J)+ETA(I+1,J)+ZETA(I+1,J)
      AA3=(ETA(I+1,J)/CSU(J)+ETA(I+1,J+1)/CSU(J))/CSU(J)
      AA4=(ETA(I,J)/CSU(J)+ETA(I,J+1)/CSU(J))/CSU(J)
      AA5=((ZETA(I,J+1)-ETA(I,J+1))+(ZETA(I+1,J+1)-ETA(I+1,J+1))
     &-(ZETA(I,J)-ETA(I,J))-(ZETA(I+1,J)-ETA(I+1,J)))*TNG(J)
      AA6=2.0*ETAMEAN*TNG(J)*TNG(J)

      IF(J.EQ.NYPOLE) THEN
      AA9=(AA1*DELY2-(ZETAMEAN-ETAMEAN)*TNG(J+1)*DELYR
     &-ETAMEAN*2.0*TNG(J)*DELYR)*VICEC(I,J+1)*UVM(I,J)*FLOAT(NPOL-0)
      ELSE
      AA9=0.0
      END IF
  
      VRT(J)=AA9+FXY(I,J)-(AA3+AA4)*DELX2*VICE(I,J,2)
     6+((ETA(I+1,J)/CSU(J)+ETA(I+1,J+1)/CSU(J))*VICE(I+1,J,2)*DELX2
     7+(ETA(I,J)/CSU(J)+ETA(I,J+1)/CSU(J))*VICE(I-1,J,2)*DELX2)/CSU(J)
      VRT(J)=(VRT(J)+AMASS(I,J)/DELTAT*VICE(I,J,2)*2.0)*UVM(I,J)
      END DO

      DO J=2,NYPOLE
      CVV(J)=CV(I,J)
      END DO
      VRT(2)=VRT(2)/BV(I,2)
      DO J=3,NYPOLE
      JM=J-1
      CVV(J)=CVV(J)/(BV(I,J)-AV(I,J)*CVV(JM))
      VRT(J)=(VRT(J)-AV(I,J)*VRT(JM))/(BV(I,J)-AV(I,J)*CVV(JM))
      END DO
      DO J=1,NYPOLE-2
      J1=NYPOLE-J
      J2=J1+1
      VRT(J1)=VRT(J1)-CVV(J1)*VRT(J2)
      END DO
      DO J=2,NYPOLE
      VICE(I,J,1)=VRT(J)
      END DO
1301  CONTINUE

c      print *, 'VICE 1st  '
c      print 15, (VICE(20,J,1),J=1,JMT)
      DO I=2,NXLCYC
      DO J=2,NYPOLE
      VICE(I,J,3)=VICE(I,J,1)
      END DO
      END DO

C NOW THE SECOND HALF

      DO J=2,NYPOLE
      DO I=2,NXLCYC
      DELX2=0.5/(DXU(I)*DXU(I))
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      RADIUS2=1.0/(RADIUS*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      ZETAMEAN=0.25*(ZETA(I,J+1)+ZETA(I+1,J+1)+ZETA(I,J)+ZETA(I+1,J))

      AA1=ETA(I,J+1)+ZETA(I,J+1)+ETA(I+1,J+1)+ZETA(I+1,J+1)
      AA2=ETA(I,J)+ZETA(I,J)+ETA(I+1,J)+ZETA(I+1,J)
      AA3=(ETA(I+1,J)/CSU(J)+ETA(I+1,J+1)/CSU(J))/CSU(J)
      AA4=(ETA(I,J)/CSU(J)+ETA(I,J+1)/CSU(J))/CSU(J)
      AA6=2.0*ETAMEAN*TNG(J)*TNG(J)

      AU(I,J)=-AA4*DELX2*UVM(I,J)
      BU(I,J)=((AA3+AA4)*DELX2+AA6*RADIUS2
     &+AMASS(I,J)/DELTAT*2.0+DRAGS(I,J))*UVM(I,J)+(1.0-UVM(I,J))
      CU(I,J)=-AA3*DELX2*UVM(I,J)
      END DO
      END DO
      DO J=2,NYPOLE
      AU(2,J)=0.0
      CU(NXLCYC,J)=0.0
      CU(2,J)=CU(2,J)/BU(2,J)
      END DO


      DO J=2,NYPOLE
      DO I=2,NXLCYC

      DELX2=0.5/(DXU(I)*DXU(I))
      DELY2=0.5/(DYU(J)*DYU(J))
      DELYR=0.5/(DYU(J)*RADIUS)
      ETAMEAN=0.25*(ETA(I,J+1)+ETA(I+1,J+1)+ETA(I,J)+ETA(I+1,J))
      ZETAMEAN=0.25*(ZETA(I,J+1)+ZETA(I+1,J+1)+ZETA(I,J)+ZETA(I+1,J))

      AA1=ETA(I,J+1)+ZETA(I,J+1)+ETA(I+1,J+1)+ZETA(I+1,J+1)
      AA2=ETA(I,J)+ZETA(I,J)+ETA(I+1,J)+ZETA(I+1,J)
      AA3=(ETA(I+1,J)/CSU(J)+ETA(I+1,J+1)/CSU(J))/CSU(J)
      AA4=(ETA(I,J)/CSU(J)+ETA(I,J+1)/CSU(J))/CSU(J)
      AA5=((ZETA(I,J+1)-ETA(I,J+1))+(ZETA(I+1,J+1)-ETA(I+1,J+1))
     &-(ZETA(I,J)-ETA(I,J))-(ZETA(I+1,J)-ETA(I+1,J)))*TNG(J)
      AA6=2.0*ETAMEAN*TNG(J)*TNG(J)

      IF(I.EQ.2) THEN
      AA9=AA4*DELX2*VICEC(I-1,J)*UVM(I,J)*FLOAT(LCYC-0)
      ELSE IF(I.EQ.NXLCYC) THEN
      AA9=AA3*DELX2*VICEC(I+1,J)*UVM(I,J)*FLOAT(LCYC-0)
      ELSE
      AA9=0.0
      END IF
      FXY1(I,J)=AA9+AMASS(I,J)/DELTAT*VICE(I,J,1)*2.0
     1-AA5*DELYR*VICE(I,J,1)
     1-(AA1+AA2)*DELY2*VICE(I,J,1)
     1+AA1*DELY2*VICE(I,J+1,1)-((ZETAMEAN-ETAMEAN)*TNG(J+1)*DELYR
     1+ETAMEAN*2.0*TNG(J)*DELYR)*VICE(I,J+1,1)
     2+AA2*DELY2*VICE(I,J-1,1)+((ZETAMEAN-ETAMEAN)*TNG(J-1)*DELYR
     2+ETAMEAN*2.0*TNG(J)*DELYR)*VICE(I,J-1,1)
      END DO
      END DO

      DO 1201 J=2,NYPOLE
      DO I=2,NXLCYC
      URT(I)=FXY(I,J)+FXY1(I,J)
      URT(I)=URT(I)*UVM(I,J)
      END DO

      DO I=2,NXLCYC
      CUU(I)=CU(I,J)
      END DO
      URT(2)=URT(2)/BU(2,J)
      DO I=3,NXLCYC
      IM=I-1
      CUU(I)=CUU(I)/(BU(I,J)-AU(I,J)*CUU(IM))
      URT(I)=(URT(I)-AU(I,J)*URT(IM))/(BU(I,J)-AU(I,J)*CUU(IM))
      END DO
      DO I=1,NXLCYC-2
      J1=NXLCYC-I
      J2=J1+1
      URT(J1)=URT(J1)-CUU(J1)*URT(J2)
      END DO
      DO I=2,NXLCYC
      VICE(I,J,1)=URT(I)
      END DO
1201  CONTINUE

c      print *, 'VICE 2st  '
c      print 15, (VICE(20,J,1),J=1,JMT)

      DO J=2,NYPOLE
      DO I=2,NXLCYC
      UICE(I,J,1)=UICE(I,J,1)*UVM(I,J)
      VICE(I,J,1)=VICE(I,J,1)*UVM(I,J)
      END DO
      END DO

      RETURN
      END

#else
      subroutine relax
      return
      end
c
#endif
