#ifdef ice_model

C SET UP ICE MODEL
      SUBROUTINE SETICE
#include "size.h"
#include "size_ice.h"
      COMMON /ICE_STUFF/UICE(NX1,NY1,3),VICE(NX1,NY1,3),ETA(NX1,NY1)
     1,ZETA(NX1,NY1),DRAGS(NX1,NY1),DRAGA(NX1,NY1),AMASS(NX1,NY1)
     3,FORCEX(NX1,NY1),FORCEY(NX1,NY1),UICEC(NX1,NY1),VICEC(NX1,NY1)
     4,OUT1(NX1,NY1),OUT2(NX1,NY1),AREA(NX1,NY1,3)
      COMMON/TRANS/HEFF(NX1,NY1,3),HCORR(NX1,NY1)
      COMMON/ARRAY/HEFFM(NX1,NY1),UVM(NX1,NY1)
      COMMON/OUTFLO/OUT(NX1,NY1)
      COMMON/OFL/OFLUX(NX1,NY1)
      COMMON/OFL1/OFLUX1(NX1,NY1),OFLUX2(NX1,NY1),OFLUX3(NX1,NY1)
     1,OFLUX4(NX1,NY1)
      COMMON/S1/SALT(NX1,NY1)
      COMMON/WATER1/WATR(NX1,NY1)
      COMMON/RIV/RIVER(NX1,NY1),RAIN(NX1,NY1)
      COMMON/DAY/IDELT,NSTEPS
      COMMON/STEP1/DELTAT,DELTAX,DELTAY
      COMMON/DIFF/HDF(NX1,NY1)
      COMMON/NEG/YNEG(NX1,NY1)
      COMMON/MIX/TMIX(NX1,NY1),TICE(NX1,NY1)
      COMMON/COUNT/ICOUNT
      COMMON/GWIND/GAIRX(NX1,NY1),GAIRY(NX1,NY1)
      COMMON/GWATXY/GWATX(NX1,NY1),GWATY(NX1,NY1)
      COMMON/ICE1/UO(NX1,NY1,2),VO(NX1,NY1,2),UOA(NX1,NY1,2)
     1,VOA(NX1,NY1,2),DPX(NX1,NY1),DPY(NX1,NY1)
      COMMON/WIND/WINDX(NX1,NY1),WINDY(NX1,NY1)
      COMMON/SNOW/HSNO(NX1,NY1)
      COMMON/NET1/HGROW(NX1,NY1)
      COMMON/RATE/FHEFF(NX1,NY1),FO(NX1,NY1)
      COMMON/COR1/SINEN(NX1,NY1)
c  The next sentence is for 7 thickness strips
      COMMON/SEV/TICES(NX1,NY1,7),FHEFP(NX1,NY1),HICEP(NX1,NY1)
      COMMON/PBLHEAT/HSENS(NX1,NY1),HLATE(NX1,NY1)
      COMMON/EMON/NDW
      character*32 stamp
      character*80 iotext
      character*60 expnam
      logical init, first, restrt
      namelist /contrl/ init, runlen
c
#include "coord.h"
#include "grdvar.h"
#include "levind.h"
c
      COMMON /ICEGRID/DXTICE(NX1),DYTICE(NY1),DXUICE(NX1), DYUICE(NY1)
     1  ,CSTICE(NY1),CSUICE(NY1),TNGTICE(NY1),TNGICE(NY1),SINEICE(NY1)
      COMMON /ICE_PARA/ERROR,DIFF1,LAD,SU1,A22,HO

C MIXING TIME STEP
      ERROR=.000005
      DIFF1=.002
      DIFF1=2.0*DIFF1
      DIFF1=4.0*DIFF1
      A22=0.15
      HO=0.5
C DOUBLE HO BECAUSE OF MOD IN GROWTH
      HO=2.0*HO
      LAD=2

      radius   = 6370.0e5
      radian = 360.0/(2.0*3.1416)
      degtcm = radius/radian

C   OPEN FILES FOR ZHANG DATA (INTERANNUAL STUDY)
      CALL SETUP(365,IDELT,NSTEPS,imt,jmt)
C NOW INITIALIZE COUNTER
      SU1=0.0
      write(*,*) icount, idelt, nsteps
c
c  get grid info
c
#ifdef read_my_grid
c
      write(*,*) 'read grid.dta'
      call getunit (io, 'grid.dta', 'unformatted sequential rewind')
      read (io) imt1, jmt1, km1
      read (io) (dxtdeg(i),i=1,imt)
     &,         (dytdeg(j),j=1,jmt)
     &,         (dxudeg(i),i=1,imt)
     &,         (dyudeg(j),j=1,jmt)
     &,         (dzt(k),k=1,km)
     &,         (dzw(k),k=0,km)
     &,         (xt(i),i=1,imt)
     &,         (xu(i),i=1,imt)
     &,         (yt(j),j=1,jmt)
     &,         (yu(j),j=1,jmt)
     &,         (zt(k),k=1,km)
     &,         (zw(k),k=1,km)
      call relunit (io)
#endif

      write(*,*)(dxtdeg(i),i=1,imt)
     &,         (dytdeg(j),j=1,jmt)
     &,         (dxudeg(i),i=1,imt)
     &,         (dyudeg(j),j=1,jmt)
c     &,         (xt(i),i=1,imt)
c     &,         (xu(i),i=1,imt)
c     &,         (yt(j),j=1,jmt)
c     &,         (yu(j),j=1,jmt)

c
c-----------------------------------------------------------------------
c     convert grid resolution to cm
c-----------------------------------------------------------------------
c
      do jrow=1,jmt
        dyt(jrow) = dytdeg(jrow)*degtcm
        dyu(jrow) = dyudeg(jrow)*degtcm
      enddo
c
      do i=1,imt
        dxt(i) = dxtdeg(i)*degtcm
        dxu(i) = dxudeg(i)*degtcm
      enddo
#ifdef cyclic
      dxt(1)   = dxt(imt-1)
      dxt(imt) = dxt(2)
      dxu(1)   = dxu(imt-1)
      dxu(imt) = dxu(2)
#endif

      do jrow=1,jmt
        phi(jrow)   = yu(jrow)/radian
        phit(jrow)  = yt(jrow)/radian
        cst(jrow)   = cos(phit(jrow))
        csu(jrow)   = cos(phi (jrow))
        sine(jrow)  = sin(phi(jrow))
        tng(jrow)   = sine(jrow)/csu(jrow)
      enddo

      DO I=1,NX1
      DXTICE(I)=DXT(I)*0.01
      DXUICE(I)=DXU(I)*0.01
      END DO
      DO J=1,NY1
      DYTICE(J)=DYT(J)*0.01
      DYUICE(J)=DYU(J)*0.01
      CSTICE(J)=CST(J)
      CSUICE(J)=CSU(J)
#ifdef northpole
      IF(J.EQ.NY1) THEN
      TNGTICE(J)=TNGTICE(NY)
      ELSE
      TNGTICE(J)=SIN(PHIT(J))/CST(J)
      ENDIF
#else
      TNGTICE(J)=SIN(PHIT(J))/CST(J)
#endif
      TNGICE(J)=TNG(J)
      SINEICE(J)=SINE(J)
      END DO
#ifdef northpole
      TNGICE(NY1)=TNG(NY)
      CSUICE(NY1)=CSU(NY)
#endif

#ifdef rot_grid
c
c     read geographic latitude from a file
c

#else
      DO I=1,IMT
      DO J=1,JMT
      SINEN(I,J)=SIN(PHI(J))
      END DO
      END DO
#endif

#ifdef read_my_kmt
      call getunit (io, 'kmt.dta'
     &,             'unformatted sequential rewind ieee')
c
c     skip header record and read dimensional info
c
      read (io) stamp, iotext, expnam
      read (io) imax, jmax, kmax
      read (io) stamp, iotext, expnam
      read (io) kmt
      call relunit (io)
#endif

#ifdef fill_isolated_cells
c
c-----------------------------------------------------------------------
c     fill isolated cells or potholes at all levels in kmt
c     filled kmt array is just the maximum of the surrounding kmu levels
c     symmetry conditions are automatic, if set on kmu
c-----------------------------------------------------------------------
c
      do i=1,imt-1
      do j=1,jmt-1
        kmu(i,j) = min(kmt(i,j), kmt(i+1,j), kmt(i,j+1), kmt(i+1,j+1))
      end do
      end do

      n = 0
      write (*,'(/a)') 'Searching for isolated T cells...'
      do i=2,imt-1
        do j=2,jmt-1
          k = max (kmu(i,j), kmu(i-1,j), kmu(i,j-1), kmu(i-1,j-1))
          if (kmt(i,j) .ne. k) n = n + 1
          kmt(i,j) = k
        enddo
      enddo
      if (n .gt. 0) then
        write (*,*) '-> Found ',n,' and filled them in.'
      else
        write (*,*) '-> None Found.'
      endif
c
      call kmtbc (kmt, imt, jmt)
#endif

      do i=1,imt-1
      do j=1,jmt-1
        kmu(i,j) = min(kmt(i,j), kmt(i+1,j), kmt(i,j+1), kmt(i+1,j+1))
      end do
      end do

#ifdef cyclic
c
c     set cyclic conditions on eastern and western boundary
c
      do jrow=1,jmt
        kmu(1,jrow)   = kmu(imt-1,jrow)
        kmu(imt,jrow) = kmu(2,jrow)
      enddo
#endif

      do j=60,30,-1
        write(*,'(31i3)')(kmt(i,j),i=60,90)
      end do

c      PRINT *,'IN SETICE'
      print *, 'DYUICE'
      print 159, (DYUICE(J),J=1,JMT)
      print *, 'DXUICE  '
      print 159, (DXUICE(I),I=1,IMT)
      print *, 'DXTICE  '
      print 159, (DXTICE(I),I=1,IMT)
      print *, 'DYT  '
      print 159, (DYTICE(J),J=1,JMT)
      print *, 'CST  '
      print 159, (CSTICE(J),J=1,JMT)
      print *, 'CSU  '
      print 159, (CSUICE(J),J=1,JMT)
      print *, 'TNG  '
      print 159, (TNGICE(J),J=1,JMT)
      print *, 'TNGT  '
      print 159, (TNGTICE(J),J=1,JMT)
      print *, 'SINE  '
      print 159, (SINEICE(J),J=1,JMT)
159     format(7e11.4)

C NOW READ IN ICE BOUNDARIES
      CALL BNDRY
C NOW DETERMINE ICE GRID
      DO 122 J=1,NY1
      DO 122 I=1,NX1
      OUT1(I,J)=HEFFM(I,J)-OUT(I,J)
 122  CONTINUE

C NOW INITIALIZE SYSTEM
C FIRST GUESS AT INITIAL HEFF AND AREA
      DO 101 J=1,NY1
      DO 101 I=1,NX1
      OFLUX1(I,J)=0.0
      OFLUX2(I,J)=0.0
      OFLUX3(I,J)=0.0
      OFLUX4(I,J)=0.0
c      RIVER(I,J)=1.0E-03*RIVER(I,J)/(DELTTT*IDELT)
      HEFF(I,J,3)=0.0
      HEFF(I,J,2)=0.0
      AREA(I,J,2)=1.0
      AREA(I,J,3)=1.0
c      HEFF(I,J,1)=(3.0)/0.91
      HEFF(I,J,1)=(1.0)/0.91
      YNEG(I,J)=0.0D+00
      TICE(I,J)=273.0D+00
      HEFF(I,J,1)=HEFF(I,J,1)*OUT(I,J)
c      HSNO(I,J)=0.2*HEFF(I,J,1)
      HSNO(I,J)=0.3
      AREA(I,J,1)=OUT(I,J)
      UO(I,J,2)=0.0
      VO(I,J,2)=0.0
      DO 101 IT=1,7
      TICES(I,J,IT)=TICE(I,J)
 101  CONTINUE

C NOW ZERO OUT VELOCITY AND OTHERS
      DO 102 J=1,NY1
      DO 102 I=1,NX1
      UICE(I,J,3)=0.0
      UICE(I,J,2)=0.0
      UICE(I,J,1)=0.0
      VICE(I,J,3)=0.0
      VICE(I,J,2)=0.0
      VICE(I,J,1)=0.0
      UICEC(I,J)=0.0
      VICEC(I,J)=0.0
 102  CONTINUE
C READ WINDS
      CALL GEO(GAIRX,GAIRY) 
      REWIND(98)
C
C NOW GET FIRST VALUE OF U AND V
      CALL FORM(UICE,VICE,ETA,ZETA,DRAGS,DRAGA,GAIRX,GAIRY,GWATX,GWATY
     2,  FORCEX,FORCEY,HEFF,AMASS,AREA)

C NOW SET AMASS=0 AND DEFINE INITIAL VISCOSITY
      DO 103 J=1,NY1
      DO 103 I=1,NX1
      AMASS(I,J)=1000.0
      ZETA(I,J)=HEFF(I,J,1)*(1.0D+11)
      ETA(I,J)=ZETA(I,J)/4.0
 103  CONTINUE
      CALL RELAX(UICE,VICE,ETA,ZETA,DRAGS,DRAGA,AMASS,FORCEX,FORCEY
     1,ERROR,UICEC,VICEC)
#ifdef cyclic
      DO J=1,NY1
      UICE(1,J,1)=UICE(NX,J,1)
      VICE(1,J,1)=VICE(NX,J,1)
      UICE(NX1,J,1)=UICE(2,J,1)
      VICE(NX1,J,1)=VICE(2,J,1)
      END DO
#endif

C READ OCEAN CURRENT ONCE
      READ(94)((UO(I,J+1,2),I=1,IMT),J=1,JMT-2)
      READ(94)((VO(I,J+1,2),I=1,IMT),J=1,JMT-2)
      CLOSE(94)

C NOW START STANDARD PREDICTOR CORRECTOR PROCEDURE
      call getunit (ioun, 'namelist.contrl'
     &,             'formatted sequential rewind')
      read  (ioun, contrl)
      call relunit (ioun)
      IF(INIT) GOTO 113
      call getunit (iorest, 'i.restart'
     &,             'unformatted sequential rewind')
      READ(iorest)(((UICE(I,J,K),I=1,NX),J=1,NY),K=1,3)
      READ(iorest)(((VICE(I,J,K),I=1,NX),J=1,NY),K=1,3)
      READ(iorest)(((HEFF(I,J,K),I=1,NX1),J=1,NY1),K=1,3)
      READ(iorest)(((AREA(I,J,K),I=1,NX1),J=1,NY1),K=1,3)
      READ(iorest)((YNEG(I,J),I=1,NX1),J=1,NY1)
      READ(iorest)(((UO (I,J,K),I=1,NX1),J=1,NY1),K=1,2)
      READ(iorest)(((VO (I,J,K),I=1,NX1),J=1,NY1),K=1,2)
      READ(iorest)(((UOA(I,J,K),I=1,NX1),J=1,NY1),K=1,2)
      READ(iorest)(((VOA(I,J,K),I=1,NX1),J=1,NY1),K=1,2)
      READ(iorest)((DPX (I,J),I=1,NX1),J=1,NY1)
      READ(iorest)((DPY (I,J),I=1,NX1),J=1,NY1)
      READ(iorest)((TMIX(I,J),I=1,NX1),J=1,NY1)
      READ(iorest)(((TICES(I,J,ITICES),I=1,NX1),J=1,NY1),ITICES=1,7)
      READ(iorest)((HSNO(I,J),I=1,NX1),J=1,NY1)
      PRINT *, 'READING ICE RESTART FILES FROM FILE ',iorest
      call relunit (iorest)
  113 CONTINUE
      RETURN
      END
c
#else
      subroutine setice
      return
      end
c
#endif
