#ifdef ice_model

      SUBROUTINE TEARDROP(UICE,VICE,PRESS,ETA,ZETA,ECCEN,ZMAX,ZMIN)
C SUBROUTINE CALCULATES STRAIN RATES AND VISCOUS PARAMETERS
#include "size.h"
#include "size_ice.h"
      DIMENSION UICE(NX1,NY1,3),VICE(NX1,NY1,3),PRESS(NX1,NY1)
     1,ETA(NX1,NY1),ZETA(NX1,NY1),E11(NX1,NY1),E22(NX1,NY1)
     2,E12(NX1,NY1),ZMAX(NX1,NY1),ZMIN(NX1,NY1)
      COMMON/STEP1/DELTAT,DELTAX,DELTAY
      COMMON/ARRAY/HEFFM(NX1,NY1),UVM(NX1,NY1)
      COMMON /ICEGRID/DXT(NX1),DYT(NY1),DXU(NX1),DYU(NY1)
     1       ,CST(NY1),CSU(NY1),TNGT(NY1),TNG(NY1),SINE(NY1)
      REAL a_ice, aaa, e1_ice, e2_ice, ck_ice
     &   , thegama1, thegama2, x1_ice, tensile_stress

      ECM2=1.0/(ECCEN**2)
      GMIN=1.0D-20
      RADIUS=6370.E3
      tensile_stress=0.05  ! tunable parameter
C NOW EVALUATE STRAIN RATES
      DO 101 J=2,NY
      DO 101 I=2,NX
      E11(I,J)=0.5/(DXT(I)*CST(J))*(UICE(I,J,1)+UICE(I,J-1,1)
     1-UICE(I-1,J,1)-UICE(I-1,J-1,1))-0.25*(VICE(I,J,1)+VICE(I-1,J,1)
     2+VICE(I-1,J-1,1)+VICE(I,J-1,1))*TNGT(J)/RADIUS
      E22(I,J)=0.5/DYT(J)*(VICE(I,J,1)+VICE(I-1,J,1)
     1                    -VICE(I,J-1,1)-VICE(I-1,J-1,1))
      E12(I,J)=0.5*(0.5/DYT(J)*(UICE(I,J,1)+UICE(I-1,J,1)
     1                    -UICE(I,J-1,1)-UICE(I-1,J-1,1))
     2        +0.5/(DXT(I)*CST(J))*(VICE(I,J,1)+VICE(I,J-1,1)
     3-VICE(I-1,J,1)-VICE(I-1,J-1,1))+0.25*(UICE(I,J,1)+UICE(I-1,J,1)
     4+UICE(I-1,J-1,1)+UICE(I,J-1,1))*TNGT(J)/RADIUS)
 101  CONTINUE

! Teardrop with tensile stress, see Zhang and Rothrock (2005) - JGR
      DO J=2,NY
      DO I=2,NX

      E1_ICE=0.5*(E11(I,J)+E22(I,J))
      IF(E1_ICE.GE.0.0D+00) THEN
      E1_ICE=MAX(GMIN,E1_ICE)
      ELSE
      E1_ICE=MIN(-GMIN,E1_ICE)
      END IF

      E2_ICE=0.5*SQRT((E11(I,J)-E22(I,J))**2+4.0*E12(I,J)*E12(I,J))
      E2_ICE=MAX(GMIN,E2_ICE)

c ck is e1/e2
      ck_ice=e1_ice/e2_ice

c get some tensile
      a_ice=tensile_stress

      aaa=(4.0-2.0*a_ice)/3.0

      zeta(i,j)=zmax(i,j)
      ETA(I,J)=ECM2*ZETA(I,J)
c      s11(i,j)=press(i,j)

      if((e1_ice.eq.gmin.or.e1_ice.eq.-gmin).and.e2_ice.eq.gmin) then
      thegama1=0.0E+00
      thegama2=0.0E+00
      zeta(i,j)=zmax(i,j)
      ETA(I,J)=ECM2*ZETA(I,J)

      else if(e1_ice.ge.e2_ice.and.e1_ice.gt.gmin) then

      x1_ice=-(0.01-0.01*(1.0-e2_ice/e1_ice))
      x1_ice=x1_ice+a_ice   ! add tensile stress

      x1_ice=MAX(-0.999999,x1_ice)

      thegama1=x1_ice*press(i,j)/aaa

      zeta(i,j)=(thegama1+0.5*press(i,j))*0.5/e1_ice
c the next lines for replacement method
      ZETA(I,J)=MIN(ZMAX(I,J),ZETA(I,J))
      ZETA(I,J)=MAX(ZMIN(I,J),ZETA(I,J))

      thegama2=-(x1_ice-a_ice)*sqrt(1.0+x1_ice)*press(i,j)
      eta(i,j)=thegama2*0.5/e2_ice
      ETA(I,J)=MIN(ZMAX(I,J),ETA(I,J))
      ETA(I,J)=MAX(ZMIN(I,J),ETA(I,J))

      press(i,j)=2.0*(zeta(i,j)*e1_ice*2.0-thegama1)

      else
      x1_ice=(-(6.0*(1.0+a_ice)-2.0*ck_ice*ck_ice)
     &      +2.0*ck_ice*sqrt(ck_ice*ck_ice+3.0*(1.0+a_ice)))/9.0

      x1_ice=x1_ice+a_ice   ! add tensile stress
      x1_ice=MAX(-0.999999,x1_ice)

      thegama1=x1_ice*press(i,j)/aaa ! this should be correct
      zeta(i,j)=(thegama1+0.5*press(i,j))*0.5/e1_ice

c the next lines for replacement method
      ZETA(I,J)=MIN(ZMAX(I,J),ZETA(I,J))
      ZETA(I,J)=MAX(ZMIN(I,J),ZETA(I,J))

      thegama2=-(x1_ice-a_ice)*sqrt(1.0+x1_ice)*press(i,j)
      eta(i,j)=thegama2*0.5/e2_ice
      ETA(I,J)=MIN(ZMAX(I,J),ETA(I,J))
      ETA(I,J)=MAX(ZMIN(I,J),ETA(I,J))

      press(i,j)=2.0*(zeta(i,j)*e1_ice*2.0-thegama1)

      end if

      enddo
      enddo


C NOW PUT MIN AND MAX VISCOSITIES IN
      DO J=1,NY1
      DO I=1,NX1
      ZETA(I,J)=AMIN1(ZMAX(I,J),ZETA(I,J))
      ZETA(I,J)=AMAX1(ZMIN(I,J),ZETA(I,J))
      END DO
      END DO

#ifdef northpole
      AAA=0.0
      DO I=2,NX1-1
      AAA=AAA+ZETA(I,NY1-1)
      END DO
      AAA=AAA/FLOAT(NX1-2)
      DO I=1,NX1
      ZETA(I,NY1)=AAA
      END DO
#endif
#ifdef cyclic
      DO J=1,NY1
      ZETA(1,J)=ZETA(NX1-1,J)
      ZETA(NX1,J)=ZETA(2,J)
      END DO
#endif

      DO 102 J=1,NY1
      DO 102 I=1,NX1
      E11(I,J)=E11(I,J)*HEFFM(I,J)
      E22(I,J)=E22(I,J)*HEFFM(I,J)
      E12(I,J)=E12(I,J)*HEFFM(I,J)
      SS11=(ZETA(I,J)-ETA(I,J))*(E11(I,J)+E22(I,J))-PRESS(I,J)*0.5
 102  CONTINUE
      RETURN
      END

#else
      subroutine teardrop
      return
      end
c
#endif
