c
c     when writing unformatted data records in MOM, each data record is
c     preceeded by a header record which was written as:
c     write(unit) stamp, iotext, expnam
c     where stamp is a 32 character specification of the model date &
c     time corresponding to the time step when the data was written and
c     iotext is a 80 character description of what is in the
c     data record and how it is to be read. expnam is a 60 character
c     experiment name which shows which experiment wrote the data.
c     this makes it easy to decipher any unformatted output from the
c     model by using a program similar to the following:
c
      program decifr
c
c-----------------------------------------------------------------------
c      decifer an unformatted file from MOM by showing the header
c      records. the file needs to copied to file "fort.21"
c-----------------------------------------------------------------------
c
      parameter(imax=152,jmax=111,kmax=45,ntmax=2)
      real *4 dxtdeg(imax),dxudeg(imax),dytdeg(jmax),dyudeg(jmax)
      real *4 dzt(kmax),dzw(0:kmax)
      real *4 xt(imax),xu(imax),yt(jmax),yu(jmax),zt(kmax),zw(kmax)
     &,t(imax,kmax,ntmax),u(imax,kmax),v(imax,kmax),adv_vbt(imax,jmax)
     &,stf(imax,ntmax),smf(imax,2),psi(imax,jmax)
     &,clon(imax,jmax),clat(imax,jmax)
      character*32 stamp
      character*80 iotext,fn,fn1,fn2,fn3
      character*60 expnam
      character*12 name3d(20), name2d(20)
c
      ios = 21
c      fn='/data/zhang3/MOM_2/EXP/LEV2_CSM3_SRB/WORK/snapshots.dta'
c      open(ios,file=fn,form='unformatted',access='sequential')
      rewind ios

      open(1,file='GIM_UPDATES/grid.dta'
     &,form='unformatted',access='sequential')
      open(2,file='grid_lon_lat.draw.dta')

c      fn1='/home/zhang/work/Mom2/LEV2_CSM3_SRB/Data/uo9.dat'
c      fn2='/home/zhang/work/Mom2/3x3CSM/Data/xuyu.dat'
c      fn3='/home/zhang/work/Mom2/3x3CSM/Data/xtyt.dat'
c      open(22,file=fn1,form='unformatted',access='sequential')
c      open(23,file=fn2,form='formatted',access='sequential')
c      open(24,file=fn3,form='formatted',access='sequential')

      imt=imax
      jmt=jmax
      km=kmax

      read (1) imt1, jmt1, km1
      read (1) (dxtdeg(i),i=1,imt)
     &,         (dytdeg(j),j=1,jmt)
     &,         (dxudeg(i),i=1,imt)
     &,         (dyudeg(j),j=1,jmt)
     &,         (dzt(k),k=1,km)
     &,         (dzw(k),k=0,km)
     &,         (xt(i),i=1,imt)
     &,         (xu(i),i=1,imt)
     &,         (yt(j),j=1,jmt)
     &,         (yu(j),j=1,jmt)
     &,         (zt(k),k=1,km)
     &,         (zw(k),k=1,km)

      do i=1,imt
      do j=1,jmt
      clon(i,j)=xt(i)
      clat(i,j)=yt(j)
      write(*,*) i,j,clon(i,j),clat(i,j)
      end do
      end do

      write(2,'(10f8.2)') clon
      write(2,'(10f8.2)') clat

      go to 5451
      do nshots=1,12

c        read the header record

        read (ios) stamp, iotext, expnam
        write (*,'(1x,a32,1x,a80)') stamp, iotext
        read(ios) reltim, period, imt, jmt, km, nt, n3d, n2d
        write(*,*) reltim, period, imt, jmt, km, nt, n3d, n2d

        read (ios) stamp, iotext, expnam
c        write (*,'(1x,a32,1x,a80)') stamp, iotext, expnam
        write (*,'(1x,a32,1x,a80)') stamp, iotext
        read(ios) (xt(i),i=1,imt)

        read (ios) stamp, iotext, expnam
        write (*,'(1x,a32,1x,a80)') stamp, iotext
        read(ios) (xu(i),i=1,imt)

        read (ios) stamp, iotext, expnam
        write (*,'(1x,a32,1x,a80)') stamp, iotext
        read(ios) (yt(j),j=1,jmt)

        read (ios) stamp, iotext, expnam
        write (*,'(1x,a32,1x,a80)') stamp, iotext
        read(ios) (yu(j),j=1,jmt)

        read (ios) stamp, iotext, expnam
        write (*,'(1x,a32,1x,a80)') stamp, iotext
        read(ios) (zt(k),k=1,km)

        read (ios) stamp, iotext, expnam
        write (*,'(1x,a32,1x,a80)') stamp, iotext
        read(ios) (zw(k),k=1,km)

        read (ios) stamp, iotext, expnam
        write (*,'(1x,a32,1x,a80)') stamp, iotext
c        read (ios) (name3d(1:12)(n),n=1,n3d)
c     &            ,(name2d*(1:12)(n),n=1,n2d)
        read (ios) (name3d(n),n=1,n3d)
     &            ,(name2d(n),n=1,n2d)

c
        if(nshots.eq.1) then
c          write(22) reltim, period, imt, jmt, km, nt, n3d, n2d
c          write(*,*) reltim, period, imt, jmt, km, nt, n3d, n2d
          write(22) (xu(i),i=1,imt)
          write(22) (yu(j),j=1,jmt)
c          write(23,'(f10.2)') (xu(i),i=1,imt)
c          write(23,'(f10.2)') (yu(j),j=1,jmt)
c          write(24,'(f10.2)') (xt(i),i=1,imt)
c          write(24,'(f10.2)') (yt(j),j=1,jmt)
        end if
c

        do jrow=1,jmt
          do m=1,nt
            read (ios) stamp, iotext, expnam
            write (*,'(1x,a32,1x,a80)') stamp, iotext
            read (ios) ((t(i,k,m),i=1,imt),k=1,km)
          end do
          read (ios) stamp, iotext, expnam
          write (*,'(1x,a32,1x,a80)') stamp, iotext
          read (ios) ((u(i,k),i=1,imt),k=1,km)

          read (ios) stamp, iotext, expnam
          write (*,'(1x,a32,1x,a80)') stamp, iotext
          read (ios) ((v(i,k),i=1,imt),k=1,km)

          read (ios) stamp, iotext, expnam
          write (*,'(1x,a32,1x,a80)') stamp, iotext
          read (ios) ((adv_vbt(i,k),i=1,imt),k=1,km)

          read (ios) stamp, iotext, expnam
          write (*,'(1x,a32,1x,a80)') stamp, iotext
          read (ios) ((stf(i,n),i=1,imt),n=1,nt)

          read (ios) stamp, iotext, expnam
          write (*,'(1x,a32,1x,a80)') stamp, iotext
          read (ios) ((smf(i,n),i=1,imt),n=1,2)

          read (ios) stamp, iotext, expnam
          write (*,'(1x,a32,1x,a80)') stamp, iotext
          read (ios) (psi(i,jrow),i=1,imt)

c          write(22) (u(i,1),i=1,imt)
c          write(22) (v(i,1),i=1,imt)
c          write(22) (u(i,2),i=1,imt)
c          write(22) (v(i,2),i=1,imt)
c          write(22) (u(i,3),i=1,imt)
c          write(22) (v(i,3),i=1,imt)
          write(22) (u(i,9),i=1,imt)
          write(22) (v(i,9),i=1,imt)
c          write(22) (u(i,12),i=1,imt)
c          write(22) (v(i,12),i=1,imt)

        end do
      enddo
      write (*,*) " => end of file on fort.",ios
5451  continue
      stop
      end

